#include <qmessagebox.h> 
#include <qstring.h> 
#include <qfiledialog.h>
#include <qcheckbox.h>
#include <cmath>

//general std class
#include <string> 

//this project class
#include "doubleEdit.h" 
#include "definition.h"
#include "iniFile.h"
#include "showResults.h"

class   WidDoubleEdit;
class   QString;
class   ShowResults;

QString filename; // versionNumber;
//	versionNnumber = "0.4.3.3" ;
int isDataChanged = true ;
//enum  InputType{iMy, iMx, iMach};
#   define  PI 3.1415926535897932384626433832795028


WidDoubleEdit *kInput;
WidDoubleEdit *pInput;
WidDoubleEdit *rInput;
WidDoubleEdit *TInput;
WidDoubleEdit *MachInput;
WidDoubleEdit *MyInput;
WidDoubleEdit *MxInput;
WidDoubleEdit *AlphaInput;
WidDoubleEdit *ThetaInput;
WidDoubleEdit *p0Input;
WidDoubleEdit *t0Input;
WidDoubleEdit *TbarInput;
WidDoubleEdit *RbarInput;
WidDoubleEdit *FLDInput;
WidDoubleEdit *PARInput;
ShowResults *showResults;
    QRadioButton* radioSubSonic;
    QRadioButton* radioSuperSonic;
    QRadioButton* radioBothSonic;


void gdForm::init()
{ 
	double k;
	kInput = new WidDoubleEdit (1.2, 2.0, 5,"Cp/Cv=k", this, "kInput") ;
    connect(kInput, SIGNAL(valueChanged(double )),
            this, SLOT(valueChange(double )));
            //this, SIGNAL(valueChange(double value)));
//    connect(kInput, SIGNAL(textChanged(const QString&)),
//            this, SLOT(valueChange(double value)));
//    connect(kInput, SIGNAL(clicked()),
//            this, SLOT(valueChanged(double value)));
	kInput->setGeometry( QRect( 300, 37, 150, 45 ) );
	kInput->setValue( 1.4 );
	whatInputGroup->setEnabled(false);
	inputDataGroup->setEnabled(false);
   	pInput = new WidDoubleEdit (0.+EPS, 2.0, 5,"P2/P1", inputDataGroup,
		"pInput");
   	TInput = new WidDoubleEdit (1.2, 2.0, 5,"T2/T1", inputDataGroup);
   	rInput = new WidDoubleEdit (1.2, 2.0, 5,"R2/R1", inputDataGroup);
   	MachInput = new WidDoubleEdit (0.00002, 10.0, 5,"Mach", inputDataGroup);
	k =  kInput->value();
   	MyInput = new WidDoubleEdit ( sqrt(.5*(k -1.)/k),
				 (1.0-EPS), 5,"My", inputDataGroup);
   	MxInput = new WidDoubleEdit ((1.+EPS), 10.0, 5,"Mx", inputDataGroup);
   	AlphaInput = new WidDoubleEdit (0., 90.0, 5,"Alpha", inputDataGroup);
   	ThetaInput = new WidDoubleEdit (0., 90.0, 5,"Alpha", inputDataGroup);
   	p0Input = new WidDoubleEdit (0., 0.5, 5,"Pbar", inputDataGroup);
   	t0Input = new WidDoubleEdit (0., 0.5, 5,"Tbar", inputDataGroup);
   	TbarInput = new WidDoubleEdit (0., (2./(1.-k)), 5,"Tbar", inputDataGroup);
   	RbarInput = new WidDoubleEdit (0., 1.0, 5,"Rbar", inputDataGroup);
	FLDInput = new WidDoubleEdit (0., 100.0, 5,"fld", inputDataGroup);
	PARInput = new WidDoubleEdit (0., 300.0, 5,"PAR", inputDataGroup);

    connect(MyInput, SIGNAL(valueChanged(double )),
            this, SLOT(newData()));
    connect(MxInput, SIGNAL(valueChanged(double )),
            this, SLOT(newData()));
    radioSubSonic = new  QRadioButton (  inputDataGroup, "SubSonic" );
    radioSubSonic->setGeometry( QRect( 300, 15, 150, 20 ) );
    radioSubSonic->setText("SubSonic");
    radioSuperSonic = new QRadioButton (  inputDataGroup, "SuperSonic" );
	radioSuperSonic->setGeometry( QRect( 300, 45, 150, 20 ) );
	radioSuperSonic->setText("SuperSonic");
    radioBothSonic = new QRadioButton (  inputDataGroup, "Both" );
	radioBothSonic->setGeometry( QRect( 300, 75, 150, 20 ) );
	radioBothSonic->setText("Both");
    connect(radioSubSonic, SIGNAL(clicked()),
            this, SLOT(branchSelected()));
    connect(radioSuperSonic, SIGNAL(clicked()),
            this, SLOT(branchSelected()));
    connect(radioMaximum, SIGNAL(clicked()),
            this, SLOT(allowMaxOblique()));

	radioStandard->setChecked(true);
	string notice;
	notice = "The range of Possible Values that can be used<p>";
	notice += "when you get to it";
	rangeNotice->setText(notice);
	clearInputBoxs() ;
	clearShockDynamicsInput() ;
}

void gdForm::helpAbout()
{
	QString notice, notice1, caption;

    notice = "<h2>Gas Dynamics Calculator 0.4.3.3</h2>" ;
    notice += "<p>Copyright &copy; 2005, 2006 Dr. Genick Bar-Meir";
    notice += "<p>Gas Dynamics Calculator is a small application that " ;
    notice += "calculates several quantities in different ";
    notice += "flow models.  ";
    //notice += notice1.setNum( 1.2);
                                                                                
    QMessageBox::about(this , "About Gas Dynamics Calculator", notice );
}


void gdForm::helpIndex()
{
	notImplementedYet();
}

void gdForm::helpContents()
{
	notImplementedYet();
}

void gdForm::clearRadio()
{
	whatInputGroup->setButton(-1);
	radioP->setEnabled(false);
	//radioP->setDown(false);
	radioP->setChecked( false );
	radioP->setShown(false);
	radioT->setEnabled(false);
	radioT->setChecked(false);
	radioR->setEnabled(false);
	radioR->setChecked(false);
	radioMach->setEnabled(false);
	radioMach->setDown(false);
	radioMach->setChecked(false);
	radioFLD->setEnabled(false);
	radioFLD->setChecked(false);
	radioMy->setEnabled(false);
	radioMy->setChecked(false);
	radioPAR->setEnabled(false);
	radioPAR->setChecked(false);
	radioAlpha->setEnabled(false);
	radioAlpha->setChecked(false);
	radioTheta->setEnabled(false);
	radioTheta->setChecked(false);
	radioP0->setEnabled(false);
	radioP0->setChecked(false);
	radioMx->setEnabled(false);
	radioMx->setChecked(false);
	radioT0->setEnabled(false);
	radioT0->setChecked(false);
	radioR0->setEnabled(false);
	radioR0->setChecked(false);
	radioDT->setShown(false);
	radioDT->setEnabled(false);
	radioDT->setChecked(false);
	radioSubSonic->setEnabled(false);
	radioSubSonic->setChecked(false);
	radioSuperSonic->setEnabled(false);
	radioSuperSonic->setChecked(false);
	radioBothSonic->setEnabled(false);
	radioBothSonic->setChecked(false);
	rangeNotice->setShown(false);
}

void gdForm::setParameters()
{
	if (modelGroup->selected() != 0){
		whatInputGroup->setEnabled(true);	
		isDataChanged = true;
	}
	clearRadio();
	clearInputBoxs();
	if (modelGroup->selected() == radioShock){
		radioP->setShown(true);
		radioP->setEnabled(true);
		radioT->setEnabled(true);
		radioR->setEnabled(true);
		radioP->setText("Py/Px");
		radioT->setText("Ty/Tx");
		radioR->setText("Ry/Rx");
		//radioMach->setEnabled(true);
		//radioFLD->setEnabled(true);
		//radioPAR->setEnabled(true);
		//radioAlpha->setEnabled(true);
		//radioTheta->setEnabled(true);
		radioMy->setEnabled(true);
		radioMx->setEnabled(true);
		radioMy->setShown(true);
		radioMx->setShown(true);
		radioP0->setEnabled(true);
		radioP0->setShown(true);
		//radioT0->setEnabled(true);
		radioR0->setShown(true);
		radioR0->setEnabled(true);
		radioMx->setText("Mx");
		//radioMy->setGeometry(QRect( 30, 37, 180, 45 ));
		radioMy->setText("My");
		radioP0->setText("P0y/P0x");
        radioT0->setText("T0y/T0x");
        radioR0->setText("R0y/R0x");
		//clearInputBoxs();
	}
	else if (modelGroup->selected() == radioOblique){
		//radioP->setEnabled(true);
		//radioT->setEnabled(true);
		//radioR->setEnabled(true);
		radioP->setText("P2/P1");
		radioT->setText("T2/T1");
		radioR->setText("R2/R1");
		//radioMach->setEnabled(true);
		//radioFLD->setEnabled(true);
		//radioMy->setEnabled(true);
		//radioPAR->setEnabled(true);
		radioDT->setShown(true);
		radioDT->setEnabled(true);
		radioDT->setText("Delta and Theta");
		radioAlpha->setEnabled(true);
		radioAlpha->setText("Delta and Mx");
		radioTheta->setEnabled(true);
		radioTheta->setText("Theta and Mx");
		//radioP0->setEnabled(true);
		//radioMx->setEnabled(true);
		//radioT0->setEnabled(true);
		//clearInputBoxs();
	}
	else if (modelGroup->selected() == radioShockDynamics){
		clearInputBoxs();
	}
	else if (modelGroup->selected() == radioisentropic){
        //radioP->setEnabled(true);
        //radioT->setEnabled(true);
        //radioR->setEnabled(true);
		radioP->setText("P2/P1");
		radioT->setText("T2/T1");
		radioR->setText("R2/R1");
        radioMach->setEnabled(true);
        //radioFLD->setEnabled(true);
        //radioMy->setEnabled(true);
        radioPAR->setEnabled(true);
        radioPAR->setShown(true);
        radioPAR->setText("PAR");
        radioAlpha->setEnabled(true);
        radioAlpha->setText("A/A*");
        //radioTheta->setEnabled(true);
        radioP0->setEnabled(true);
        radioR0->setEnabled(true);
        //radioMx->setEnabled(true);
        radioT0->setEnabled(true);
        radioP0->setText("Pbar");
        radioT0->setText("Tbar");
        radioR0->setText("Rbar");
		//clearInputBoxs();
    }
	else if (modelGroup->selected() == radioFanno){
        radioP->setEnabled(true);
        radioP->setShown(true);
        radioT->setEnabled(true);
        radioR->setEnabled(true);
		radioP->setText("P/P*");
		radioT->setText("T/T*");
		radioR->setText("R/R*");
		radioMach->setText("Mach");
        radioMach->setEnabled(true);
        radioFLD->setEnabled(true);
        radioFLD->setShown(true);
        //radioMy->setEnabled(true);
        //radioMy->setText("M2");
        radioPAR->setEnabled(true);
        radioPAR->setShown(true);
        radioPAR->setText("M1&fld");
        //radioAlpha->setEnabled(true);
        //radioTheta->setEnabled(true);
        radioP0->setEnabled(true);
        radioP0->setText("P0/P0*");
        //radioMx->setEnabled(true);
        //radioMx->setText("M1");
        //radioT0->setEnabled(true);
        //radioT0->setText("T0/T0*");
		//clearInputBoxs();
    }
	else if (modelGroup->selected() == radioRayliegh){
        radioP->setEnabled(true);
        radioT->setEnabled(true);
        radioR->setEnabled(true);
		radioP->setText("P/P*");
		radioT->setText("T/T*");
		radioR->setText("R/R*");
		radioR->setShown(true);
		radioP->setShown(true);
		radioT->setShown(true);
        radioMach->setEnabled(true);
        //radioFLD->setEnabled(true);
        radioMy->setEnabled(true);
        radioMy->setText("M2");
        //radioPAR->setEnabled(true);
        //radioAlpha->setEnabled(true);
        //radioTheta->setEnabled(true);
        radioP0->setEnabled(true);
        radioMx->setEnabled(true);
        radioMx->setText("M1");
        radioT0->setEnabled(true);
        radioP0->setText("P02/P01");
        radioT0->setText("T02/T01");
        //radioR0->setText("R02/R01");
        //radioR0->setEnabled(true);
        //radioR0->setShown(true);
		radioFLD->setShown(false);
		radioMy->setShown(false);
		radioMx->setShown(false);
    }
	else if (modelGroup->selected() == radiopm){
        //radioP->setEnabled(true);
        //radioT->setEnabled(true);
        //radioR->setEnabled(true);
		radioP->setText("P/P0");
		radioT->setText("T/T0");
		radioR->setText("R2/R1");
        radioMach->setEnabled(true);
        radioMach->setShown(true);
        //radioFLD->setEnabled(true);
        //radioMy->setEnabled(true);
        //radioMy->setText("M1");
        //radioPAR->setEnabled(true);
        radioPAR->setText("PAR");
        radioAlpha->setEnabled(true);
        radioAlpha->setText("nu");
        //radioTheta->setEnabled(true);
        radioP0->setEnabled(true);
        radioP0->setShown(true);
        //radioMx->setEnabled(true);
        //radioMx->setText("M2");
        radioT0->setEnabled(true);
        radioT0->setShown(false);
        //radioMx->setEnabled(true);
        radioP0->setText("Pbar");
        radioT0->setText("Tbar");
		//clearInputBoxs();
    }
	else if (modelGroup->selected() == radioIsothermal){
        radioP->setEnabled(true);
        radioP->setShown(true);
        radioT->setEnabled(true);
        radioT->setShown(false);
        radioR->setEnabled(true);
		radioP->setText("P/P*");
		radioT->setText("T/T*");
		radioR->setText("R/R*");
        radioMach->setEnabled(true);
        radioFLD->setEnabled(true);
        radioMy->setEnabled(true);
        radioMy->setText("M2");
		radioMy->setShown(false);
        radioP0->setEnabled(true);
        radioMx->setEnabled(true);
        radioMx->setText("M1");
		radioMx->setShown(false);
        radioT0->setEnabled(true);
        radioP0->setText("P0/P0*");
        radioT0->setText("T0/T0*");
		//clearInputBoxs();
    }
	else if (modelGroup->selected() == radioIsoNozzle){
        radioP->setEnabled(true);
        radioP->setText("P/P*");
		radioP->setShown(true);
		radioP->setEnabled(true);
		radioP->setText("P/P*");
		radioT->setText("T2/T1");
		radioR->setText("R2/R1");
        //radioT->setEnabled(true);
        radioR->setEnabled(true);
        radioR->setText("R/R*");
        radioMach->setEnabled(true);
        //radioFLD->setEnabled(true);
        //radioMy->setEnabled(true);
        //radioMy->setText("M1");
        radioPAR->setEnabled(false);
        radioPAR->setShown(false);
        //radioPAR->setText("TAR");
        //radioAlpha->setEnabled(true);
        //radioAlpha->setText("nu");
        //radioTheta->setEnabled(true);
        radioP0->setEnabled(true);
        //radioMx->setEnabled(true);
        //radioMx->setText("M2");
        radioT0->setEnabled(true);
        radioP0->setText("P0/P0*");
        radioT0->setText("T0/T0*");
        radioR0->setText("R0/R0*");
		//clearInputBoxs();
    }
}

void gdForm::clearInputBoxs()
{
    pInput->setEnabled(false);
    pInput->setShown(false);
    rInput->setEnabled(false);
    rInput->setShown(false);
    TInput->setEnabled(false);
    TInput->setShown(false);
    MachInput->setEnabled(false);
    MachInput->setShown(false);
    MyInput->setEnabled(false);
    MyInput->setShown(false);
    MxInput->setEnabled(false);
    MxInput->setShown(false);
    AlphaInput->setEnabled(false);
    AlphaInput->setShown(false);
	p0Input->setEnabled(false);
	p0Input->setShown(false);
	t0Input->setEnabled(false);
	t0Input->setShown(false);
    TbarInput->setEnabled(false);
    TbarInput->setShown(false);
    RbarInput->setEnabled(false); 
    RbarInput->setShown(false); 
    AlphaInput->setEnabled(false); 
    AlphaInput->setShown(false); 
    ThetaInput->setEnabled(false); 
    ThetaInput->setShown(false); 
	FLDInput->setEnabled(false);
	FLDInput->setShown(false);
	PARInput->setEnabled(false);
	PARInput->setShown(false);
    radioSubSonic->setEnabled(false);
    radioSubSonic->setChecked(false);
    radioSubSonic->setShown(false);
    radioSuperSonic->setEnabled(false);
    radioSuperSonic->setChecked(false);
    radioSuperSonic->setShown(false);
    radioBothSonic->setEnabled(false);
    radioBothSonic->setChecked(false);
    radioBothSonic->setShown(false);
}

void gdForm::setInput()
{
    if (whatInputGroup->selected() != 0){
        inputDataGroup->setEnabled(true);
		isDataChanged = true;
    }
	else {
		clearInputBoxs();
		return;
	}
	clearInputBoxs();
	rangeNotice->setShown(false);
	double * tmpRange;
    tmpRange = new double[2];
	InputType inputBox;
	double k ;
	k =  kInput->value();
	if (modelGroup->selected() == radioIsoNozzle){ 
		if (whatInputGroup->selected() == radioMach){
			MachInput->setGeometry( QRect( 30, 37, 180, 45 ) );
			MachInput->setValue(1.3);
			MachInput->setEnabled(true);
			MachInput->setShown(true);
		}
		else if (whatInputGroup->selected() == radioP){
			pInput->setGeometry( QRect( 30, 37, 180, 45 ) );
			pInput->setRange(1., exp(k*0.5) );
			pInput->setEnabled(true);
			pInput->setShown(true);
			tmpRange = pInput->getRange();
			pInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
			selectBranch() ;
		}
		else if (whatInputGroup->selected() == radioR){
			rInput->setGeometry( QRect( 30, 37, 180, 45 ) );
			rInput->setRange(1., exp(k*0.5) );
			rInput->setEnabled(true);
			rInput->setShown(true);
			tmpRange = rInput->getRange();
			rInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
			selectBranch() ;
		}
		else if (whatInputGroup->selected() == radioP0) {
            p0Input->setGeometry( QRect( 30, 37, 180, 45 ) );
            p0Input->setEnabled(true);
            p0Input->setShown(true);
            p0Input->setLabel(radioP0->text());
			p0Input->setRange(1., exp(k*0.5)* pow((2.0/(k+1.)), (k /(k -1.))) );
			tmpRange = p0Input->getRange();
			p0Input->setValue(0.5*(tmpRange[0]+tmpRange[1]));
			selectBranch() ;
		}
		else if (whatInputGroup->selected() == radioT0){
            t0Input->setGeometry( QRect( 30, 37, 180, 45 ) );
            t0Input->setEnabled(true);
            t0Input->setShown(true);
            t0Input->setLabel(radioT0->text());
       		t0Input->setRange( (2./(1.+k)-EPS), 1.0);
			tmpRange = t0Input->getRange();
			t0Input->setValue(0.5*(tmpRange[0]+tmpRange[1]));
			selectBranch() ;
		}
	}
	else if (modelGroup->selected() == radioOblique){
		if (whatInputGroup->selected() == radioAlpha){
			MxInput->setLabel("Mx");
			MxInput->setGeometry( QRect( 300, 37, 180, 45 ) );
			MxInput->setEnabled(true);
			MxInput->setShown(true);
			MxInput->setRange(1.+EPS, 10. );
			tmpRange = MxInput->getRange();
			MxInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
    		AlphaInput->setGeometry( QRect( 30, 37, 180, 45 ) );
    		AlphaInput->setLabel( "delta" );
			AlphaInput->setEnabled(true);
			AlphaInput->setShown(true);
			AlphaInput->setRange(0.+EPS, 90. );
			tmpRange = AlphaInput->getRange();
			AlphaInput->setValue(0.05*(tmpRange[0]+tmpRange[1]));
		}
		else if (whatInputGroup->selected() == radioTheta){
			MxInput->setLabel("Mx");
			MxInput->setGeometry( QRect( 300, 37, 180, 45 ) );
			MxInput->setEnabled(true);
			MxInput->setShown(true);
			MxInput->setRange(1.+EPS, 10. );
			tmpRange = MxInput->getRange();
			MxInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
    		ThetaInput->setGeometry( QRect( 30, 37, 180, 45 ) );
    		ThetaInput->setLabel( "theta" );
			ThetaInput->setEnabled(true);
			ThetaInput->setShown(true);
			ThetaInput->setRange(0.+EPS, 90. );
			tmpRange = ThetaInput->getRange();
			ThetaInput->setValue(0.1*(tmpRange[0]+tmpRange[1]));
		}
        else if (whatInputGroup->selected() == radioDT){
            AlphaInput->setLabel("delta");
            AlphaInput->setGeometry( QRect( 30, 37, 180, 45 ) );
            AlphaInput->setEnabled(true);
            AlphaInput->setShown(true);
            AlphaInput->setRange(0+EPS, 40. );
            tmpRange = AlphaInput->getRange();
            AlphaInput->setValue(0.1*(tmpRange[0]+tmpRange[1]));
            ThetaInput->setGeometry( QRect( 300, 37, 180, 45 ) );
            ThetaInput->setLabel( "theta" );
            ThetaInput->setEnabled(true);
            ThetaInput->setShown(true);
            ThetaInput->setRange(0.+EPS, 70. );
            tmpRange = ThetaInput->getRange();
            ThetaInput->setValue(0.2*(tmpRange[0]+tmpRange[1]));
        }
        else if (whatInputGroup->selected() == radioMx){
			MxInput->setGeometry( QRect( 30, 37, 180, 45 ) );
			MxInput->setEnabled(true);
			MxInput->setShown(true);
			MxInput->setLabel(radioMx->text());
			MxInput->setValue(2.0);
			MxInput->setRange(1.0+EPS, 30.0 );
            tmpRange = MxInput->getRange();
            MxInput->setValue(0.1*(tmpRange[0]+tmpRange[1]));
        }
	}
	else if (modelGroup->selected() == radioShockDynamics){
		if (whatInputGroup->selected() == radioAlpha){//Ux
			TInput->setLabel("T[C]"); // 
			TInput->setGeometry( QRect( 300, 37, 180, 45 ) );
			TInput->setEnabled(true);
			TInput->setShown(true);
			TInput->setRange(100., 900. );
			tmpRange = MxInput->getRange();
			MxInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
    		AlphaInput->setGeometry( QRect( 30, 37, 180, 45 ) );
    		AlphaInput->setLabel("Ux[m/sec]");
			AlphaInput->setEnabled(true);
			AlphaInput->setShown(true);
			AlphaInput->setRange(10.+EPS, 900. );
			tmpRange = AlphaInput->getRange();
			AlphaInput->setValue(0.1*(tmpRange[0]+tmpRange[1]));
		}
		else if (whatInputGroup->selected() == radioMach){
			MachInput->setLabel(radioMach->text());
			MachInput->setGeometry( QRect( 30, 37, 180, 45 ) );
			MachInput->setEnabled(true);
			MachInput->setShown(true);
			MachInput->setRange ( EPS, 100.0);
			tmpRange = MachInput->getRange();
			MachInput->setValue(0.005*(tmpRange[0]+tmpRange[1]));
		}
		else if (whatInputGroup->selected() == radioMy){
			MyInput->setLabel(radioMy->text());
			MyInput->setGeometry( QRect( 30, 37, 180, 45 ) );
			MyInput->setEnabled(true);
			MyInput->setShown(true);
			MyInput->setRange ( sqrt(.5*(k -1.)/k)+EPS, 1.0);
			tmpRange = MyInput->getRange();
			MyInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
		}
        else if (whatInputGroup->selected() == radioDT){
            AlphaInput->setLabel("Us");
            AlphaInput->setGeometry( QRect( 30, 37, 180, 45 ) );
            AlphaInput->setEnabled(true);
            AlphaInput->setShown(true);
            AlphaInput->setRange(250., 3000. );
            tmpRange = AlphaInput->getRange();
            AlphaInput->setValue(0.3*(tmpRange[0]+tmpRange[1]));
            TInput->setGeometry( QRect( 300, 37, 180, 45 ) );
            TInput->setLabel( "Tx" );
            TInput->setEnabled(true);
            TInput->setShown(true);
            TInput->setRange(20., 1000. );
            tmpRange = TInput->getRange();
            TInput->setValue(0.2*(tmpRange[0]+tmpRange[1]));
        }
        else if (whatInputGroup->selected() == radioMx){ 
			MxInput->setGeometry( QRect( 30, 37, 180, 45 ) );
			MxInput->setEnabled(true);
			MxInput->setShown(true);
			MxInput->setLabel(radioMx->text());
			MxInput->setRange(.10+EPS, 30.0 );
            tmpRange = MxInput->getRange();
            MxInput->setValue(0.1*(tmpRange[0]+tmpRange[1]));
        }
        else if (whatInputGroup->selected() == radioP){ 
			MxInput->setGeometry( QRect( 30, 37, 180, 45 ) );
			MxInput->setEnabled(true);
			MxInput->setShown(true);
			MxInput->setLabel(radioP->text());
			MxInput->setRange(.10+EPS, 30.0 );
            tmpRange = MxInput->getRange();
            MxInput->setValue(0.1*(tmpRange[0]+tmpRange[1]));
        }
		else if (whatInputGroup->selected() == radioT){
			MyInput->setLabel(radioT->text());
			MyInput->setGeometry( QRect( 30, 37, 180, 45 ) );
			MyInput->setEnabled(true);
			MyInput->setShown(true);
			MyInput->setRange ( sqrt(.5*(k -1.)/k)+EPS, 1.0);
			tmpRange = MyInput->getRange();
			MyInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
		}
		else if (whatInputGroup->selected() == radioR){
			MyInput->setLabel(radioR->text());
			MyInput->setGeometry( QRect( 30, 37, 180, 45 ) );
			MyInput->setEnabled(true);
			MyInput->setShown(true);
			MyInput->setRange ( EPS, sqrt(2./k / (k -1.)) );
			tmpRange = MyInput->getRange();
			MyInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
		}
		else if (whatInputGroup->selected() == radioTheta){
			pInput->setLabel(radioTheta->text());
			pInput->setGeometry( QRect( 30, 37, 180, 45 ) );
			pInput->setEnabled(true);
			pInput->setShown(true);
			pInput->setRange ( EPS, 60.);
			tmpRange = pInput->getRange();
			pInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
		}
		else if (whatInputGroup->selected() == radioFLD){ // Mx My'
			MxInput->setGeometry( QRect( 30, 37, 180, 45 ) );
            MxInput->setLabel( "<b>Mx</b>" );
			MxInput->setEnabled(true);
			MxInput->setShown(true);
			MxInput->setRange ( 1+ EPS, 60.);
			tmpRange = MxInput->getRange();
			MxInput->setValue(0.02*(tmpRange[0]+tmpRange[1]));
            MyInput->setGeometry( QRect( 300, 37, 180, 45 ) );
            MyInput->setLabel( "<i>My'</i>" );
            MyInput->setEnabled(true);
            MyInput->setShown(true);
            MyInput->setRange(0.+EPS, 0.5 );
            tmpRange = MyInput->getRange();
            MyInput->setValue(0.2*(tmpRange[0]+tmpRange[1]));
		}
		else if (whatInputGroup->selected() == radioT0){ // Mx' My'
			MxInput->setGeometry( QRect( 30, 37, 180, 45 ) );
            MxInput->setLabel( "<i>Mx'</i>" );
			MxInput->setEnabled(true);
			MxInput->setShown(true);
			MxInput->setRange ( EPS, 3.);
			tmpRange = MxInput->getRange();
			MxInput->setValue(0.03*(tmpRange[0]+tmpRange[1]));
            MyInput->setGeometry( QRect( 300, 37, 180, 45 ) );
            MyInput->setLabel( "<i>My'</i>" );
            MyInput->setEnabled(true);
            MyInput->setShown(true);
            MyInput->setRange(0.+EPS, 1.5 );
            tmpRange = MyInput->getRange();
            MyInput->setValue(0.2*(tmpRange[0]+tmpRange[1]));
		}
		else if (whatInputGroup->selected() == radioP0){ // Mx' My'
			MxInput->setGeometry( QRect( 30, 37, 180, 45 ) );
            MxInput->setLabel( "<i>Mx'</i>" );
			MxInput->setEnabled(true);
			MxInput->setShown(true);
			MxInput->setRange ( EPS, 2.5);
			tmpRange = MxInput->getRange();
			MxInput->setValue(0.3*(tmpRange[0]+tmpRange[1]));
            MyInput->setGeometry( QRect( 300, 37, 180, 45 ) );
            MyInput->setLabel( "<i>My'</i>" );
            MyInput->setEnabled(true);
            MyInput->setShown(true);
            MyInput->setRange(MxInput->value()+EPS, 1.5 );
            tmpRange = MyInput->getRange();
            MyInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
		}
		else if (whatInputGroup->selected() == radioR0){ // Mx My'
			MxInput->setGeometry( QRect( 30, 37, 180, 45 ) );
            MxInput->setLabel( "<b>Mx'</b>" );
			MxInput->setEnabled(true);
			MxInput->setShown(true);
			MxInput->setRange ( 1+ EPS, 3.);
			tmpRange = MxInput->getRange();
			MxInput->setValue(0.2*(tmpRange[0]+tmpRange[1]));
            MyInput->setGeometry( QRect( 300, 37, 180, 45 ) );
            MyInput->setLabel( "<i>My</i>" );
            MyInput->setEnabled(true);
            MyInput->setShown(true);
            MyInput->setRange(sqrt(0.5*(k-1.)/k) +EPS, 1.0 - EPS);
            tmpRange = MyInput->getRange();
            MyInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
		}
	}
	else if (modelGroup->selected() == radioShock){
		if (whatInputGroup->selected() == radioMx){
			MxInput->setGeometry( QRect( 30, 37, 180, 45 ) );
			MxInput->setEnabled(true);
			MxInput->setShown(true);
			MxInput->setLabel(radioMx->text());
			MxInput->setValue(2.0);
			MxInput->setRange(1.0+EPS, 30.0 );
			//selectBranch() ;
			//rangeNotice->setText("The possible range, 1.0-50.0");
			inputBox=iMx;
			setNotice(inputBox);
		}
		else if (whatInputGroup->selected() == radioMy){
        	k =  kInput->value();
            MyInput->setGeometry( QRect( 30, 37, 180, 45 ) );
            MyInput->setEnabled(true);
            MyInput->setShown(true);
            MyInput->setLabel(radioMy->text());
        	MyInput->setRange( sqrt(.5*(k -1.)/k)+EPS, 1.0);
        	tmpRange = MyInput->getRange();
        	MyInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
			inputBox=iMy;
			setNotice(inputBox);
		}
		else if (whatInputGroup->selected() == radioP0){
            p0Input->setGeometry( QRect( 30, 37, 180, 45 ) );
            p0Input->setEnabled(true);
            p0Input->setShown(true);
            p0Input->setLabel(radioP0->text());
			p0Input->setRange(EPS, 1.0);
            tmpRange = p0Input->getRange();
            p0Input->setValue(0.5*(tmpRange[0]+tmpRange[1]));
            inputBox=iP0;
            setNotice(inputBox);
		}
		else if (whatInputGroup->selected() == radioR0){
            RbarInput->setGeometry( QRect( 30, 37, 180, 45 ) );
            RbarInput->setEnabled(true);
            RbarInput->setShown(true);
            RbarInput->setLabel(radioR0->text());
            RbarInput->setRange(EPS, 1.0);
            tmpRange = RbarInput->getRange();
            RbarInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
            inputBox=iR0;
            setNotice(inputBox);
		}
		else if (whatInputGroup->selected() == radioP ){
			pInput->setGeometry( QRect( 30, 37, 180, 45 ) );
			pInput->setEnabled(true);
			pInput->setShown(true);
			pInput->setLabel(radioP->text());
			pInput->setRange( 1.0, 100.);
            tmpRange = pInput->getRange();
			pInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
            inputBox=iP;
            setNotice(inputBox);
		}
		else if (whatInputGroup->selected() == radioT ){
			TInput->setGeometry( QRect( 30, 37, 180, 45 ) );
			TInput->setEnabled(true);
			TInput->setShown(true);
			TInput->setLabel(radioT->text());
			TInput->setRange( 1.0, 100.);
            tmpRange = TInput->getRange();
			TInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
            inputBox=iT;
            setNotice(inputBox);
		}
		else if (whatInputGroup->selected() == radioR ){
			rInput->setGeometry( QRect( 30, 37, 180, 45 ) );
			rInput->setEnabled(true);
			rInput->setShown(true);
			rInput->setLabel(radioR->text());
			rInput->setRange( 1.0, (k+1.)/(k-1.));
            tmpRange = rInput->getRange();
			rInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
            inputBox=iR;
            setNotice(inputBox);
		}
	}
	else if (modelGroup->selected() == radioisentropic){
		if (whatInputGroup->selected() == radioAlpha){
			//AlphaInput is used as A/A* now
			AlphaInput->setGeometry( QRect( 30, 37, 180, 45 ) );
			AlphaInput->setEnabled(true);
			AlphaInput->setShown(true);
			AlphaInput->setLabel(radioAlpha->text());
			AlphaInput->setValue(5.0);
			AlphaInput->setRange(1.0+EPS, 300.0 );
			selectBranch() ;
		}
		else if (whatInputGroup->selected() == radioMach){
			MachInput->setGeometry( QRect( 30, 37, 180, 45 ) );
			MachInput->setValue(1.3);
			MachInput->setEnabled(true);
			MachInput->setShown(true);
		}
		else if (whatInputGroup->selected() == radioPAR){
			PARInput->setGeometry( QRect( 30, 37, 180, 45 ) );
			PARInput->setEnabled(true);
			PARInput->setShown(true);
			tmpRange = PARInput->getRange();
			PARInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
            selectBranch() ;
            inputBox=iPAR;
            setNotice(inputBox);
		}
		else if (whatInputGroup->selected() == radioP0){
            p0Input->setGeometry( QRect( 30, 37, 180, 45 ) );
            p0Input->setEnabled(true);
            p0Input->setShown(true);
            p0Input->setRange(pow((2.0/(k+1)), (k /(k -1.))) ,1.0);
            tmpRange = p0Input->getRange();
            p0Input->setValue(0.5*(tmpRange[0]+tmpRange[1]));
            selectBranch() ;
            inputBox=iP0;
            setNotice(inputBox);
		}
		else if (whatInputGroup->selected() == radioT0){
            TbarInput->setGeometry( QRect( 30, 37, 180, 45 ) );
            TbarInput->setEnabled(true);
            TbarInput->setShown(true);
            TbarInput->setRange((2.0/(k+1.)) ,1.0);
            tmpRange = TbarInput->getRange();
            TbarInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
            selectBranch() ;
		}
		else if (whatInputGroup->selected() == radioR0){
            RbarInput->setGeometry( QRect( 30, 37, 180, 45 ) );
            RbarInput->setEnabled(true);
            RbarInput->setShown(true);
			RbarInput->setRange(pow((2.0/(k+1.)), (1. /(k -1.))) ,1.0);
            tmpRange = RbarInput->getRange();
            RbarInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
            selectBranch() ;
		}
	}
	else if (modelGroup->selected() == radioFanno) {
		if (whatInputGroup->selected() == radioFLD){
			//MachInput->setGeometry( QRect( 300, 37, 180, 45 ) );
			//MachInput->setValue(0.4);
			//MachInput->setEnabled(true);
			//MachInput->setShown(true);
			FLDInput->setGeometry( QRect( 30, 37, 180, 45 ) );
			FLDInput->setEnabled(true);
			FLDInput->setShown(true);
			FLDInput->setRange((.0+EPS), 500.);
			tmpRange = FLDInput->getRange();
			FLDInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
            selectBranch() ;
		}
		else if (whatInputGroup->selected() == radioMach){
			MachInput->setGeometry( QRect( 30, 37, 180, 45 ) );
			MachInput->setValue(1.3);
			MachInput->setEnabled(true);
			MachInput->setShown(true);
			MachInput->setRange((.0+EPS), 500.);
		}
		else if (whatInputGroup->selected() == radioP0){
            p0Input->setGeometry( QRect( 30, 37, 180, 45 ) );
            p0Input->setEnabled(true);
            p0Input->setShown(true);
			p0Input->setLabel(radioP0->text());
            p0Input->setRange(1.0, 300.);
            tmpRange = p0Input->getRange();
            p0Input->setValue(0.5*(tmpRange[0]+tmpRange[1]));
		}
		else if (whatInputGroup->selected() == radioP){
            pInput->setGeometry( QRect( 30, 37, 180, 45 ) );
            pInput->setEnabled(true);
            pInput->setShown(true);
			pInput->setLabel(radioP->text());
            pInput->setRange(.0, 300.);
            tmpRange = pInput->getRange();
            pInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
		}
		else if (whatInputGroup->selected() == radioT){
            TInput->setGeometry( QRect( 30, 37, 180, 45 ) );
            TInput->setEnabled(true);
            TInput->setShown(true);
			TInput->setLabel(radioT->text());
            TInput->setRange(.0, 0.5*(k+1.));
            tmpRange = pInput->getRange();
            pInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
		}
		else if (whatInputGroup->selected() == radioR){
            rInput->setGeometry( QRect( 30, 37, 180, 45 ) );
            rInput->setEnabled(true);
            rInput->setShown(true);
			rInput->setLabel(radioR->text());
            rInput->setRange(sqrt((k-1.)/(k+1.)), 300.);
            tmpRange = rInput->getRange();
            rInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
		}
		else if (whatInputGroup->selected() == radioPAR){ // M1 & fld
			FLDInput->setGeometry( QRect( 30, 37, 180, 45 ) );
			FLDInput->setEnabled(true);
			FLDInput->setShown(true);
			FLDInput->setRange((.0+EPS), 5.);
			tmpRange = FLDInput->getRange();
			FLDInput->setValue(0.1*(tmpRange[0]+tmpRange[1]));
    		MachInput->setGeometry( QRect( 300, 37, 180, 45 ) );
			MachInput->setValue(1.3);
			MachInput->setEnabled(true);
			MachInput->setShown(true);
			MachInput->setRange((1.0+EPS), 500.);
		}
	}
	else if (modelGroup->selected() == radioIsothermal) {
		if (whatInputGroup->selected() == radioFLD){
			FLDInput->setGeometry( QRect( 30, 37, 180, 45 ) );
			FLDInput->setEnabled(true);
			FLDInput->setShown(true);
			FLDInput->setRange((.0+EPS), 500.);
			tmpRange = FLDInput->getRange();
			FLDInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
            selectBranch() ;
		}
		else if (whatInputGroup->selected() == radioMach){
			MachInput->setGeometry( QRect( 30, 37, 180, 45 ) );
			MachInput->setValue(1.3);
			MachInput->setEnabled(true);
			MachInput->setShown(true);
			MachInput->setRange((.0+EPS), 500.);
		}
		else if (whatInputGroup->selected() == radioP0){
            p0Input->setGeometry( QRect( 30, 37, 180, 45 ) );
            p0Input->setEnabled(true);
            p0Input->setShown(true);
			p0Input->setLabel(radioP0->text());
            p0Input->setRange(1.0, 300.);
            tmpRange = p0Input->getRange();
            p0Input->setValue(0.5*(tmpRange[0]+tmpRange[1]));
			selectBranch() ;
		}
		if (whatInputGroup->selected() == radioP){
            pInput->setGeometry( QRect( 30, 37, 180, 45 ) );
            pInput->setEnabled(true);
            pInput->setShown(true);
			pInput->setLabel(radioP->text());
            pInput->setRange(EPS, 300.);
            tmpRange = pInput->getRange();
            pInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
		}
		else if (whatInputGroup->selected() == radioT0){
            t0Input->setGeometry( QRect( 30, 37, 180, 45 ) );
            t0Input->setEnabled(true);
            t0Input->setShown(true);
			t0Input->setLabel(radioT0->text());
            t0Input->setRange(2.*k/(3.*k-1.), 300.);
            tmpRange = t0Input->getRange();
            t0Input->setValue(0.5*(tmpRange[0]+tmpRange[1]));
		}
		if (whatInputGroup->selected() == radioT){
            TInput->setGeometry( QRect( 30, 37, 180, 45 ) );
            TInput->setEnabled(true);
            TInput->setShown(true);
			TInput->setLabel(radioT->text());
            TInput->setRange(.0, 0.5*(k+1.));
            tmpRange = pInput->getRange();
            pInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
		}
		if (whatInputGroup->selected() == radioR){
            rInput->setGeometry( QRect( 30, 37, 180, 45 ) );
            rInput->setEnabled(true);
            rInput->setShown(true);
			rInput->setLabel(radioR->text());
            rInput->setRange(sqrt((k-1.)/(k+1.)), 300.);
            tmpRange = rInput->getRange();
            rInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
		}
	}
	else if (modelGroup->selected() == radioRayliegh) {
		if (whatInputGroup->selected() == radioMach){
			MachInput->setGeometry( QRect( 30, 37, 180, 45 ) );
			MachInput->setValue(1.3);
			MachInput->setEnabled(true);
			MachInput->setShown(true);
			MachInput->setRange((.0+EPS), 500.);
		}
		else if (whatInputGroup->selected() == radioP0){
            p0Input->setGeometry( QRect( 30, 37, 180, 45 ) );
            p0Input->setEnabled(true);
            p0Input->setShown(true);
			p0Input->setLabel(radioP0->text());
            p0Input->setRange(1.0, (k+1.)*pow(2./(k+1.),k/(k-1.0)));
            tmpRange = p0Input->getRange();
            p0Input->setValue(0.5*(tmpRange[0]+tmpRange[1]));
			selectBranch() ;
		}
		if (whatInputGroup->selected() == radioP){
            pInput->setGeometry( QRect( 30, 37, 180, 45 ) );
            pInput->setEnabled(true);
            pInput->setShown(true);
			pInput->setLabel(radioP->text());
            pInput->setRange(EPS, k+1.);
            tmpRange = pInput->getRange();
            pInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
		}
		else if (whatInputGroup->selected() == radioT0){
            t0Input->setGeometry( QRect( 30, 37, 180, 45 ) );
            t0Input->setEnabled(true);
            t0Input->setShown(true);
			t0Input->setLabel(radioT0->text());
            t0Input->setRange(EPS, 1.);
            tmpRange = t0Input->getRange();
            t0Input->setValue(0.5*(tmpRange[0]+tmpRange[1]));
			selectBranch() ;
		}
		if (whatInputGroup->selected() == radioT){
            TInput->setGeometry( QRect( 30, 37, 180, 45 ) );
            TInput->setEnabled(true);
            TInput->setShown(true);
			TInput->setLabel(radioT->text());
            TInput->setRange(.0, 1.0);
            tmpRange = TInput->getRange();
            TInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
			selectBranch() ;
		}
		if (whatInputGroup->selected() == radioR){
            rInput->setGeometry( QRect( 30, 37, 180, 45 ) );
            rInput->setEnabled(true);
            rInput->setShown(true);
			rInput->setLabel(radioR->text());
            rInput->setRange(0.0, (k+1.)/k );
            tmpRange = rInput->getRange();
            rInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
		}
	}
	else if (modelGroup->selected() == radiopm){
		if (whatInputGroup->selected() == radioMach){
			MachInput->setGeometry( QRect( 30, 37, 180, 45 ) );
			MachInput->setValue(1.3);
			MachInput->setEnabled(true);
			MachInput->setShown(true);
		}
		if (whatInputGroup->selected() == radioAlpha){
			//AlphaInput is used as A/A* now
			AlphaInput->setGeometry( QRect( 30, 37, 180, 45 ) );
			AlphaInput->setEnabled(true);
			AlphaInput->setShown(true);
			AlphaInput->setLabel(radioAlpha->text());
			AlphaInput->setValue(5.0);
			AlphaInput->setRange(EPS, 90*(sqrt((k+1.)/(k-1))-1.) );
		}
		else if (whatInputGroup->selected() == radioPAR){
			PARInput->setGeometry( QRect( 30, 37, 180, 45 ) );
			PARInput->setEnabled(true);
			PARInput->setShown(true);
			tmpRange = PARInput->getRange();
			PARInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
            selectBranch() ;
            inputBox=iPAR;
            setNotice(inputBox);
		}
		else if (whatInputGroup->selected() == radioP0){
            p0Input->setGeometry( QRect( 30, 37, 180, 45 ) );
            p0Input->setEnabled(true);
            p0Input->setShown(true);
            //p0Input->setRange(pow((2.0/(k+1)), (k /(k -1.))) ,1.0);
            p0Input->setRange(0.0 ,1.0);
            tmpRange = p0Input->getRange();
            p0Input->setValue(0.5*(tmpRange[0]+tmpRange[1]));
            //selectBranch() ;
            //inputBox=iP0;
            //setNotice(inputBox);
		}
		else if (whatInputGroup->selected() == radioT0){
            TbarInput->setGeometry( QRect( 30, 37, 180, 45 ) );
            TbarInput->setEnabled(true);
            TbarInput->setShown(true);
            TbarInput->setRange((2.0/(k+1.)) ,1.0);
            tmpRange = TbarInput->getRange();
            TbarInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
            selectBranch() ;
		}
		else if (whatInputGroup->selected() == radioR0){
            RbarInput->setGeometry( QRect( 30, 37, 180, 45 ) );
            RbarInput->setEnabled(true);
            RbarInput->setShown(true);
			RbarInput->setRange(pow((2.0/(k+1.)), (1. /(k -1.))) ,1.0);
            tmpRange = RbarInput->getRange();
            RbarInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
            selectBranch() ;
		}
	}
//	else if (whatInputGroup->selected() == radioR0){
//    	RbarInput->setGeometry( QRect( 30, 37, 180, 45 ) );
//    	RbarInput->setEnabled(true);
//    	RbarInput->setShown(true);
//		RbarInput->setLabel(radioR0->text());
//		RbarInput->setRange((.0+EPS),  pow((2.0/(k+1)), (1. /(k -1.))) );
//		tmpRange = TbarInput->getRange();
//		RbarInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
//    	MachInput->setGeometry( QRect( 300, 37, 180, 45 ) );
//    	MachInput->setValue(1.3);
//    	MachInput->setEnabled(true);
//    	MachInput->setShown(true);
//	}
//	else if (whatInputGroup->selected() == radioAlpha){
//    	AlphaInput->setGeometry( QRect( 30, 37, 180, 45 ) );
//    	AlphaInput->setEnabled(true);
//    	AlphaInput->setShown(true);
//		AlphaInput->setLabel(radioAlpha->text());
//		AlphaInput->setValue(5.0);
//	}
//	else if (whatInputGroup->selected() == radioTheta){
//    	ThetaInput->setGeometry( QRect( 30, 37, 180, 45 ) );
//    	ThetaInput->setEnabled(true);
//    	ThetaInput->setShown(true);
//		ThetaInput->setLabel(radioTheta->text());
//		ThetaInput->setValue(5.0);
//    	MxInput->setGeometry( QRect( 300, 37, 180, 45 ) );
//    	MxInput->setValue(1.3);
//    	MxInput->setEnabled(true);
//    	MxInput->setShown(true);
//    	MxInput->setLabel("M1");
//	}
//    //setNotice(inputBox);
}

void gdForm::calculate()
{
	QString workingFileName;
	if ( filename.isEmpty() ) {
		if (canSave() == false) {
			return;
		}
		else {
			workingFileName = "-g";
			save(workingFileName);
		}
	}
	else if (filename == "-g"  ){ // -g issue
		QString notice,  caption;
		notice = "<h2>Gas Dymanics Calculator 0.4.3.3</h2>" ;
		//notice += versionNnumber ;
		notice += "<p> -g already set.  ";
		caption = "Gas Dymanics Calculator";
		//QMessageBox::warning (this , caption , notice);//,
		workingFileName = filename;
		save(workingFileName);
	}
	else if (isDataChanged == false ) {
		workingFileName = filename ;
    	QString notice,  caption;
		notice = "<h2>Gas Dymanics Calculator 0.4.3.3</h2>" ;
		notice += "<p> original file name is:  ";
		notice += workingFileName;
		caption = "Gas Dymanics Calculator";
		//QMessageBox::warning (this , caption , notice);//,
	}
	else {
		if (canSave() == false) {
			return;
		}
		else {
			workingFileName = filename ;
			//workingFileName = "-g";
			save(workingFileName);
			QString notice,  caption;
			notice = "<h2>Gas Dymanics Calculator 0.4.3.3</h2>" ;
			notice += "<p>file name is:  ";
			notice += workingFileName;
			caption = "Gas Dymanics Calculator";
			QMessageBox::warning (this , caption , notice);//,
		}
	}
	if (!showResults){
		//showResults = new ShowResults (this, "showResutls", "./data.ini");
		showResults = new ShowResults (this, "showResutls");
		//, "workingFileName");
		connect(this, SIGNAL(newData(QString)), 
			showResults, SLOT(newData(QString)));
	}
	showResults->show();
	showResults->raise();
	showResults->setActiveWindow();
	filename = workingFileName ;
	emit newData(workingFileName); 
}

int gdForm::LabelChanged()
{ //also changing range of input operation
	double k;
    if (modelGroup->selected() == radioShock && 
		whatInputGroup->selected() == radioMy){
			MyInput->setLabel(radioMy->text());
			k =  kInput->value();	
			MyInput->setRange(sqrt(.5*(k -1.)/k)+EPS,1.0);
			double * tmpRange;
			tmpRange = MyInput->getRange();
			MyInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
			MxInput->setLabel(radioMx->text());
			p0Input->setLabel(radioP0->text());
			AlphaInput->setLabel(radioAlpha->text());
	}
    else if (modelGroup->selected() == radioisentropic ){// &&
        //whatInputGroup->selected() == radioP0){
			//double M;
            //p0Input->setLabel("junk");
            if ( MachInput->value() > 1.0){ //supersonic flow M > 1
				k =  kInput->value();	
            	p0Input->setRange(0.0+EPS, pow((2.0/(k+1)), (k /(k -1.))) );
			}
			else {
				p0Input->setRange(0.0, 1.0);
			}
            double * tmpRange;
            tmpRange = MyInput->getRange();
            MyInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
    }
	isDataChanged=true;
	return true ;
}


void gdForm::fileSave()
{
    QString notice,  caption;
	if (modelGroup->selected() == 0 ){
		notice = "<h2>Gas Dymanics Calculator 0.4.3.3</h2>" ;
		notice += "<p>You need to select the model radio";
		QMessageBox::warning (this , "Gas Dymanics Calculator", notice);//,
//					 QMessageBox::Ok );
		return;
	}
    if (whatInputGroup->selected() == 0 ){
        notice = "<h2>Gas Dymanics Calculator 0.4.3.3</h2>" ;
        notice += "<p>You need to select the what Info radio";
        QMessageBox::warning (this , "Gas Dymanics Calculator", notice);//,
//                   QMessageBox::Ok );
        return;
    }

    if ( filename.isEmpty() ) {
        fileSaveAs();
        return;
    }
	save(filename);
}


void gdForm::fileSaveAs()
{
  QString fn =
	 QFileDialog::getSaveFileName( "gdc.dat",
		 "gdc files (*.gdc *.ini *.dat );;" 
         "Text files (*.txt);;"
         "Any files (*)" ,
				this, "save file dialog" "Choose a filename to save under" ); 
		// to set up the extension for the file name 
    if ( !fn.isEmpty() ) {
        filename = fn;
        fileSave();
    }
}


void gdForm::fileOpen()
{

}

void gdForm::save( QString FileName )
{
	string fileName;
	if (FileName == "-g") {
		fileName = ".dammy.dammy";	
	}
	else {
		fileName = FileName.ascii();
	}
	CIniFile iniFile( fileName ); 
	iniFile. HeaderComment("This file was created by gdc calculator.");
	iniFile. HeaderComment
		("This file can be edited if you know what you doing." );

	//iniFile.HeaderComment("data","The data input");
	iniFile.SetValueF( "data", "k", kInput->value());
	iniFile.KeyComment("data",  "The actual data");
	iniFile.SetValueF( "data", "k", kInput->value());
	if ( modelGroup->selected() == radioOblique){
		if (whatInputGroup->selected() == radioAlpha){
			iniFile.SetValueF( "data", "delta", AlphaInput->value());
			iniFile.SetValueF( "data", "Mx", MxInput->value());
		}
		else if (whatInputGroup->selected() == radioMx) {
			iniFile.SetValueF( "data", "delta", AlphaInput->value());
			iniFile.SetValueF( "data", "Mx", MxInput->value());
		} 
		else if (whatInputGroup->selected() == radioTheta) {
			iniFile.SetValueF( "data", "theta", ThetaInput->value());
			iniFile.SetValueF( "data", "Mx", MxInput->value());
		} 
		else if (whatInputGroup->selected() == radioDT) {
			iniFile.SetValueF( "data", "theta", ThetaInput->value());
			iniFile.SetValueF( "data", "delta", AlphaInput->value());
		} 
		else if (whatInputGroup->selected() == radioMx) {
			iniFile.SetValueF( "data", "M1", MxInput->value());
		}
		else {
			iniFile.SetValueF( "data", "delta", AlphaInput->value());
			iniFile.SetValueF( "data", "Mx", MxInput->value());
		}
	}
	else if ( modelGroup->selected() == radioShockDynamics){
		if (whatInputGroup->selected() == radioAlpha){
			iniFile.SetValueF( "data", "Uxp", AlphaInput->value());
			iniFile.SetValueF( "data", "Tx", TInput->value());
		}
		else if (whatInputGroup->selected() == radioMx) {
			iniFile.SetValueF( "data", "delta", AlphaInput->value());
			iniFile.SetValueF( "data", "Mx", MxInput->value());
		} 
		else if (whatInputGroup->selected() == radioTheta) {
			iniFile.SetValueF( "data", "PyPx", pInput->value());
		} 
		else if (whatInputGroup->selected() == radioDT) {
			iniFile.SetValueF( "data", "Tx", TInput->value());
			iniFile.SetValueF( "data", "Us", AlphaInput->value());
		} 
		else if (whatInputGroup->selected() == radioMy) {
			iniFile.SetValueF( "data", "My", MyInput->value());
		}
		else if (whatInputGroup->selected() == radioMach) {
			iniFile.SetValueF( "data", "Mxp", MachInput->value());
		}
		else if (whatInputGroup->selected() == radioP) {
			iniFile.SetValueF( "data", "Mx", MxInput->value());
		}
		else if (whatInputGroup->selected() == radioT) {
			iniFile.SetValueF( "data", "My", MyInput->value());
		}
		else if (whatInputGroup->selected() == radioR) {
			iniFile.SetValueF( "data", "Myp", MyInput->value());
		}
		else if (whatInputGroup->selected() == radioFLD) {
			iniFile.SetValueF( "data", "Mx", MxInput->value());
			iniFile.SetValueF( "data", "Myp", MyInput->value());
		}
		else if (whatInputGroup->selected() == radioT0) {
			iniFile.SetValueF( "data", "Mxp", MxInput->value());
			iniFile.SetValueF( "data", "Myp", MyInput->value());
		}
		else if (whatInputGroup->selected() == radioP0) {
			iniFile.SetValueF( "data", "Mxp", MxInput->value());
			iniFile.SetValueF( "data", "Myp", MyInput->value());
		}
		else if (whatInputGroup->selected() == radioR0) {
			iniFile.SetValueF( "data", "Mxp", MxInput->value());
			iniFile.SetValueF( "data", "My", MyInput->value());
		}
		else {
			iniFile.SetValueF( "data", "delta", AlphaInput->value());
			iniFile.SetValueF( "data", "Mx", MxInput->value());
		}
	}
    else if (modelGroup->selected()== radioisentropic ){
        if (whatInputGroup->selected() == radioAlpha){
            iniFile.SetValueF( "data", "Astar", AlphaInput->value());
			if (inputDataGroup->selected() ==  radioSuperSonic){
            	iniFile.SetValueF( "data", "M", 2.0);
			}
			else if (inputDataGroup->selected() ==  radioSubSonic){
            	iniFile.SetValueF( "data", "M", 0.5);
			}
			else {
        		iniFile.SetValue( "integer", "isBothBranches", "yes" );
			}
		}
		else if (whatInputGroup->selected() == radioP0){
			iniFile.SetValueF( "data", "Pbar", p0Input->value());
			if (inputDataGroup->selected() ==  radioSuperSonic){
            	iniFile.SetValueF( "data", "M", 2.0);
			}
			else if (inputDataGroup->selected() ==  radioSubSonic){
            	iniFile.SetValueF( "data", "M", 0.5);
			}
			else {
        		iniFile.SetValue( "integer", "isBothBranches", "yes" );
			}
		}
		else if (whatInputGroup->selected() == radioT0){
			iniFile.SetValueF( "data", "Tbar", TbarInput->value());
		}
		else if (whatInputGroup->selected() == radioR0 ){
			iniFile.SetValueF( "data", "Rbar", RbarInput->value());
		}
		else if (whatInputGroup->selected() == radioPAR ){
			iniFile.SetValueF( "data", "PAR", PARInput->value());
			iniFile.SetValueF( "data", "M", MachInput->value());
		}
		else if (whatInputGroup->selected() == radioMach ){
			iniFile.SetValueF( "data", "M", MachInput->value());
		}
		else {
			//do nothing
		}
	}
    else if (modelGroup->selected()== radioFanno ){
        if (whatInputGroup->selected() == radioAlpha){
            iniFile.SetValueF( "data", "Astar", AlphaInput->value());
			if (inputDataGroup->selected() ==  radioSuperSonic){
            	iniFile.SetValueF( "data", "M", 2.0);
			}
			else if (inputDataGroup->selected() ==  radioSubSonic){
            	iniFile.SetValueF( "data", "M", 0.5);
			}
			else {
        		iniFile.SetValue( "integer", "isBothBranches", "yes" );
			}
		}
		else if (whatInputGroup->selected() == radioP0){
			iniFile.SetValueF( "data", "PRzeroStar", p0Input->value());
            if (inputDataGroup->selected() ==  radioSuperSonic){
                iniFile.SetValueF( "data", "M", 2.0);
            }
            else if (inputDataGroup->selected() ==  radioSubSonic){
                iniFile.SetValueF( "data", "M", 0.5);
			}
            else {
                iniFile.SetValue( "integer", "isBothBranches", "yes" );
            }
		}
		else if (whatInputGroup->selected() == radioP){
			iniFile.SetValueF( "data", "Pbar", pInput->value());
		}
		else if (whatInputGroup->selected() == radioT0){
			iniFile.SetValueF( "data", "Tbar", TInput->value());
			iniFile.SetValueF( "data", "M", MachInput->value());
		}
		else if (whatInputGroup->selected() == radioT){
			iniFile.SetValueF( "data", "Tbar", TInput->value());
		}
		else if (whatInputGroup->selected() == radioR0 ){
			iniFile.SetValueF( "data", "RRzeroStar", rInput->value());
		}
		else if (whatInputGroup->selected() == radioR ){
			iniFile.SetValueF( "data", "Rbar", rInput->value());
		}
		else if (whatInputGroup->selected() == radioMach ){
			iniFile.SetValueF( "data", "M", MachInput->value());
		}
		else if (whatInputGroup->selected() == radioPAR ){
			iniFile.SetValueF( "data", "M1", MachInput->value());
        	iniFile.SetValueF( "data", "fld", FLDInput->value());
		}
		else if (whatInputGroup->selected() == radioFLD ){
        	iniFile.SetValueF( "data", "fld", FLDInput->value());
        	//iniFile.SetValueF( "data", "M", MachInput->value());
            if (inputDataGroup->selected() ==  radioSuperSonic){
                iniFile.SetValueF( "data", "M", 2.0);
            }
            else if (inputDataGroup->selected() ==  radioSubSonic){
                iniFile.SetValueF( "data", "M", 0.5);
            }
            else {
                iniFile.SetValue( "integer", "isBothBranches", "yes" );
            }
    	}
		else {
			//do nothing
		}
	}
    else if (modelGroup->selected()== radioIsothermal ){
        if (whatInputGroup->selected() == radioAlpha){
            iniFile.SetValueF( "data", "Astar", AlphaInput->value());
			if (inputDataGroup->selected() ==  radioSuperSonic){
            	iniFile.SetValueF( "data", "M", 2.0);
			}
			else if (inputDataGroup->selected() ==  radioSubSonic){
            	iniFile.SetValueF( "data", "M", 0.5);
			}
			else {
        		iniFile.SetValue( "integer", "isBothBranches", "yes" );
			}
		}
		else if (whatInputGroup->selected() == radioP0){
			iniFile.SetValueF( "data", "PRzeroStar", p0Input->value());
            if (inputDataGroup->selected() ==  radioSuperSonic){
                iniFile.SetValueF( "data", "M", 2.0);
            }
            else if (inputDataGroup->selected() ==  radioSubSonic){
                iniFile.SetValueF( "data", "M", 0.5);
			}
            else {
                iniFile.SetValue( "integer", "isBothBranches", "yes" );
            }
		}
		else if (whatInputGroup->selected() == radioP){
			iniFile.SetValueF( "data", "Pbar", pInput->value());
		}
		else if (whatInputGroup->selected() == radioT0){
			iniFile.SetValueF( "data", "TRzeroStar", t0Input->value());
		}
		else if (whatInputGroup->selected() == radioT){
			iniFile.SetValueF( "data", "Tbar", TInput->value());
		}
		else if (whatInputGroup->selected() == radioR0 ){
			iniFile.SetValueF( "data", "RRzeroStar", rInput->value());
		}
		else if (whatInputGroup->selected() == radioR ){
			iniFile.SetValueF( "data", "Rbar", rInput->value());
		}
		else if (whatInputGroup->selected() == radioMach ){
			iniFile.SetValueF( "data", "M", MachInput->value());
		}
		else if (whatInputGroup->selected() == radioFLD ){
        	iniFile.SetValueF( "data", "fld", FLDInput->value());
        //iniFile.SetValueF( "data", "M", MachInput->value());
            if (inputDataGroup->selected() ==  radioSuperSonic){
                iniFile.SetValueF( "data", "M", 2.0);
            }
            else if (inputDataGroup->selected() ==  radioSubSonic){
                iniFile.SetValueF( "data", "M", 0.5);
            }
            else {
                iniFile.SetValue( "integer", "isBothBranches", "yes" );
            }
    	}
		else {
			//do nothing
		}
	}
    else if (modelGroup->selected()== radioRayliegh ){
        if (whatInputGroup->selected() == radioAlpha){
            iniFile.SetValueF( "data", "Astar", AlphaInput->value());
			if (inputDataGroup->selected() ==  radioSuperSonic){
            	iniFile.SetValueF( "data", "M", 2.0);
			}
			else if (inputDataGroup->selected() ==  radioSubSonic){
            	iniFile.SetValueF( "data", "M", 0.5);
			}
			else {
        		iniFile.SetValue( "integer", "isBothBranches", "yes" );
			}
		}
		else if (whatInputGroup->selected() == radioP0){
			iniFile.SetValueF( "data", "PRzeroStar", p0Input->value());
            if (inputDataGroup->selected() ==  radioSuperSonic){
                iniFile.SetValueF( "data", "M", 2.0);
            }
            else if (inputDataGroup->selected() ==  radioSubSonic){
                iniFile.SetValueF( "data", "M", 0.5);
			}
            else {
                iniFile.SetValue( "integer", "isBothBranches", "yes" );
            }
		}
		else if (whatInputGroup->selected() == radioP){
			iniFile.SetValueF( "data", "Pbar", pInput->value());
		}
		else if (whatInputGroup->selected() == radioT0){
			iniFile.SetValueF( "data", "TRzeroStar", t0Input->value());
			if (inputDataGroup->selected() ==  radioSuperSonic){
            	iniFile.SetValueF( "data", "M", 2.0);
			}
			else if (inputDataGroup->selected() ==  radioSubSonic){
            	iniFile.SetValueF( "data", "M", 0.5);
			}
			else {
        		iniFile.SetValue( "integer", "isBothBranches", "yes" );
			}
		}
		else if (whatInputGroup->selected() == radioT){
			iniFile.SetValueF( "data", "Tbar", TInput->value());
            if (inputDataGroup->selected() ==  radioSuperSonic){
                iniFile.SetValueF( "data", "M", 2.0);
            }
            else if (inputDataGroup->selected() ==  radioSubSonic){
                iniFile.SetValueF( "data", "M", 0.5);
			}
            else {
                iniFile.SetValue( "integer", "isBothBranches", "yes" );
            }
		}
		else if (whatInputGroup->selected() == radioR0 ){
			iniFile.SetValueF( "data", "RRzeroStar", rInput->value());
		}
		else if (whatInputGroup->selected() == radioR ){
			iniFile.SetValueF( "data", "Rbar", rInput->value());
		}
		else if (whatInputGroup->selected() == radioMach ){
			iniFile.SetValueF( "data", "M", MachInput->value());
		}
		else if (whatInputGroup->selected() == radioFLD ){
        	iniFile.SetValueF( "data", "fld", FLDInput->value());
        //iniFile.SetValueF( "data", "M", MachInput->value());
            if (inputDataGroup->selected() ==  radioSuperSonic){
                iniFile.SetValueF( "data", "M", 2.0);
            }
            else if (inputDataGroup->selected() ==  radioSubSonic){
                iniFile.SetValueF( "data", "M", 0.5);
            }
            else {
                iniFile.SetValue( "integer", "isBothBranches", "yes" );
            }
    	}
		else {
			//do nothing
		}
	}
    else if (modelGroup->selected()== radioIsoNozzle ){
		if (whatInputGroup->selected() == radioP0){
			iniFile.SetValueF( "data", "PRzeroStar", p0Input->value());
            if (inputDataGroup->selected() ==  radioSuperSonic){
                iniFile.SetValueF( "data", "M", 2.0);
            }
            else if (inputDataGroup->selected() ==  radioSubSonic){
                iniFile.SetValueF( "data", "M", 0.5);
			}
            else {
                iniFile.SetValue( "integer", "isBothBranches", "yes" );
            }
		}
		else if (whatInputGroup->selected() == radioP){
			iniFile.SetValueF( "data", "Pbar", pInput->value());
		}
		else if (whatInputGroup->selected() == radioR){
			iniFile.SetValueF( "data", "Pbar", rInput->value());
		}
		else if (whatInputGroup->selected() == radioT0){
			iniFile.SetValueF( "data", "TRzeroStar", t0Input->value());
			if (inputDataGroup->selected() ==  radioSuperSonic){
            	iniFile.SetValueF( "data", "M", 2.0);
			}
			else if (inputDataGroup->selected() ==  radioSubSonic){
            	iniFile.SetValueF( "data", "M", 0.5);
			}
			else {
        		iniFile.SetValue( "integer", "isBothBranches", "yes" );
			}
		}
		else if (whatInputGroup->selected() == radioT){
			iniFile.SetValueF( "data", "Tbar", TInput->value());
            if (inputDataGroup->selected() ==  radioSuperSonic){
                iniFile.SetValueF( "data", "M", 2.0);
            }
            else if (inputDataGroup->selected() ==  radioSubSonic){
                iniFile.SetValueF( "data", "M", 0.5);
			}
            else {
                iniFile.SetValue( "integer", "isBothBranches", "yes" );
            }
		}
		else if (whatInputGroup->selected() == radioR0 ){
			iniFile.SetValueF( "data", "RRzeroStar", rInput->value());
		}
		else if (whatInputGroup->selected() == radioR ){
			iniFile.SetValueF( "data", "Rbar", rInput->value());
		}
		else if (whatInputGroup->selected() == radioMach ){
			iniFile.SetValueF( "data", "M", MachInput->value());
		}
		else if (whatInputGroup->selected() == radioFLD ){
        	iniFile.SetValueF( "data", "fld", FLDInput->value());
        //iniFile.SetValueF( "data", "M", MachInput->value());
            if (inputDataGroup->selected() ==  radioSuperSonic){
                iniFile.SetValueF( "data", "M", 2.0);
            }
            else if (inputDataGroup->selected() ==  radioSubSonic){
                iniFile.SetValueF( "data", "M", 0.5);
            }
            else {
                iniFile.SetValue( "integer", "isBothBranches", "yes" );
            }
    	}
		else {
			//do nothing
		}
	}
    else if (whatInputGroup->selected() == radioP){
		iniFile.SetValueF( "data", "Pbar", pInput->value());
		iniFile.SetValueF( "data", "M", MachInput->value());
	}
    else if (whatInputGroup->selected() == radioT){
		iniFile.SetValueF( "data", "Tbar", TInput->value());
		iniFile.SetValueF( "data", "M", MachInput->value());
	}
	else if (whatInputGroup->selected() == radioR ){
        iniFile.SetValueF( "data", "Rbar", rInput->value());
		iniFile.SetValueF( "data", "M", MachInput->value());
    }
    else if (whatInputGroup->selected() == radioP0 &&
                modelGroup->selected() == radioShock){
        iniFile.SetValueF( "data", "P0yP0x", p0Input->value());
		iniFile.SetValueF( "data", "M", MachInput->value());
	}
    else if (whatInputGroup->selected() == radioP0 &&
                modelGroup->selected() != radioShock ) {
        double * tmpRange;
        tmpRange = p0Input->getRange();
		if (modelGroup->selected()== radioisentropic  &&
        	whatInputGroup->selected() == radioP0){
			double k = kInput->value() ;
        	if ( MachInput->value() >= 1.0 && 
					p0Input->value() > pow((2.0/(k+1)), (k /(k -1.))) ){ //
				//valueChange(kInput->value()); //update according M value
	            QString notice, notice1,  caption;
				caption = "Gas Dymanics Calculator";
				notice = "<h2>Gas Dymanics Calculator 0.4.3.3</h2>" ;
				notice += "<p>Your value of Pbar is too high ";
				notice += "and will not work. ";
				notice += "<p>Therefore the value changed to: <p><b><center>" ;
				p0Input->setValue(0.5*(tmpRange[0]+tmpRange[1]));
				notice += notice1.setNum(  p0Input->value());
				notice += 
					"</center> </b><p>The highest value possible for this k = ";
				notice += notice1.setNum( k );
				notice += " is: <p> " ;
				notice += notice1.setNum(  tmpRange[1]);
				QMessageBox::warning (this , caption, notice);
			}
		}
        iniFile.SetValueF( "data", "Pbar", p0Input->value());
		iniFile.SetValueF( "data", "M", MachInput->value());
    }
    else if (whatInputGroup->selected() == radioT0 &&
                modelGroup->selected() == radioShock){
        iniFile.SetValueF( "data", "T0yT0x", p0Input->value());
		iniFile.SetValueF( "data", "M", MachInput->value());
	}
    else if (whatInputGroup->selected() == radioT0 &&
                modelGroup->selected() != radioShock ) {
        double * tmpRange;
        tmpRange = TbarInput->getRange();
		if (modelGroup->selected()== radioisentropic  &&
        	whatInputGroup->selected() == radioT0){
			double k = kInput->value() ;
        	if ( MachInput->value() >= 1.0 && 
					TbarInput->value() > (2.0/(k+1)) ){ //
				//valueChange(kInput->value()); //update according M value
	            QString notice, notice1,  caption;
				caption = "Gas Dymanics Calculator";
				notice = "<h2>Gas Dymanics Calculator 0.4.3.3</h2>" ;
				notice += "<p>Your value of Pbar is too high ";
				notice += "and will not work. ";
				notice += "<p>Therefore the value changed to: <p><b><center>" ;
				TbarInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
				notice += notice1.setNum(  TbarInput->value());
				notice += 
					"</center> </b><p>The highest value possible for this k = ";
				notice += notice1.setNum( k );
				notice += " is: <p> " ;
				notice += notice1.setNum(  tmpRange[1]);
				QMessageBox::warning (this , caption, notice);
			}
		}
        iniFile.SetValueF( "data", "Tbar", TbarInput->value());
		iniFile.SetValueF( "data", "M", MachInput->value());
    }
    else if (whatInputGroup->selected() == radioR0 &&
                modelGroup->selected() == radioShock){
        iniFile.SetValueF( "data", "R0yR0x", RbarInput->value());
		iniFile.SetValueF( "data", "M", MachInput->value());
	}
    else if (whatInputGroup->selected() == radioR0 &&
                modelGroup->selected() != radioShock ) {
        double * tmpRange;
        tmpRange = RbarInput->getRange();
		if (modelGroup->selected()== radioisentropic  &&
        	whatInputGroup->selected() == radioR0){
			double k = kInput->value() ;
        	if ( MachInput->value() >= 1.0 && 
					RbarInput->value() > pow((2.0/(k+1)), (1. /(k -1.))) ){ //
				//valueChange(kInput->value()); //update according M value
	            QString notice, notice1,  caption;
				caption = "Gas Dymanics Calculator";
				notice = "<h2>Gas Dymanics Calculator 0.4.3.3</h2>" ;
				notice += "<p>Your value of Pbar is too high ";
				notice += "and will not work. ";
				notice += "<p>Therefore the value changed to: <p><b><center>" ;
				p0Input->setValue(0.5*(tmpRange[0]+tmpRange[1]));
				notice += notice1.setNum(  p0Input->value());
				notice += 
					"</center> </b><p>The highest value possible for this k = ";
				notice += notice1.setNum( k );
				notice += " is: <p> " ;
				notice += notice1.setNum(  tmpRange[1]);
				QMessageBox::warning (this , caption, notice);
			}
		}
        iniFile.SetValueF( "data", "Rbar", RbarInput->value());
		iniFile.SetValueF( "data", "M", MachInput->value());
    }
	else if (whatInputGroup->selected() == radioMy ){
    	double * tmpRange;
    	tmpRange = MyInput->getRange();
		if ( MyInput->value() < tmpRange[0]) {
    		QString notice, notice1,  caption;
        	notice = "<h2>Gas Dymanics Calculator 0.4.3.3</h2>" ;
        	notice += "<p>Your value of My is too low ";
        	notice += "and will not work. ";
        	notice += "<p>Therefore the value changed to: <p><b><center>" ;
    		MyInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
    		notice += notice1.setNum(  MyInput->value());
        	notice += "</center> </b><p>The lowest value possible for this k = ";
    		notice += notice1.setNum(kInput->value()  );
        	notice += " is: <p> " ;
    		notice += notice1.setNum(  tmpRange[0]);
        	QMessageBox::warning (this , "Gas Dymanics Calculator", notice);//,
		} 
        iniFile.SetValueF( "data", "My", MyInput->value());
		iniFile.SetValueF( "data", "Theta", ThetaInput->value());
    }
	else if (whatInputGroup->selected() == radioAlpha ){
        iniFile.SetValueF( "data", "angle", AlphaInput->value());
		//iniFile.SetValueF( "data", "M1", MxInput->value());
    }
	else if (whatInputGroup->selected() == radioMx ){
        iniFile.SetValueF( "data", "Mx", MxInput->value());
		iniFile.SetValueF( "data", "Theta", ThetaInput->value());
    }
	else if (whatInputGroup->selected() == radioMach ){
        iniFile.SetValueF( "data", "M", MachInput->value());
    }
	else if (whatInputGroup->selected() == radioFLD ){
        iniFile.SetValueF( "data", "fld", FLDInput->value());
        //iniFile.SetValueF( "data", "M", MachInput->value());
			if (inputDataGroup->selected() ==  radioSuperSonic){
                iniFile.SetValueF( "data", "M", 2.0);
            }
            else if (inputDataGroup->selected() ==  radioSubSonic){
                iniFile.SetValueF( "data", "M", 0.5);
            }
            else {
                iniFile.SetValue( "integer", "isBothBranches", "yes" );
            }
    }
	else { //default
        iniFile.SetValueF( "data", "M", MachInput->value());
    }
	// input output section
	if (isTexBox->isChecked() == true ) {
		iniFile.SetValue( "integer", "isTex", "yes" );
	}
	else {
		iniFile.SetValue( "integer", "isTex", "no" );
	}                           
	
    if (isRangeBox->isChecked() == true ) {
        iniFile.SetValue( "integer", "isRange", "yes" );
    }
    else {
        iniFile.SetValue( "integer", "isRange", "no" );
    }
	iniFile.SetValueI( "integer", "numberNodes", 40 );
	iniFile.SetValueI( "integer", "shockLocation", 50 );
	// to insert the addional option later
	if (modelGroup->selected() == radioShockDynamics){ 
		if   (outputGroup->selected() == radioStandard)
			iniFile.SetValue( "InputOutput", "whatInfo", "infoStandard" );
		else if   (outputGroup->selected() == radioMaximum)
			iniFile.SetValue( "InputOutput", "whatInfo", "infoMax" );
		else if   (outputGroup->selected() == radioMinimum)
			iniFile.SetValue( "InputOutput", "whatInfo", "infoIteration" );
		else 
			iniFile.SetValue( "InputOutput", "whatInfo", "infoStandard" );
	}
	else if (modelGroup->selected() == radioFanno){ 
		if   (outputGroup->selected() == radioStandard)
			iniFile.SetValue( "InputOutput", "whatInfo", "infoStandard" );
		else if   (outputGroup->selected() == radioMaximum)
			iniFile.SetValue( "InputOutput", "whatInfo", "infoIteration" );
		else if   (outputGroup->selected() == radioMinimum)
			iniFile.SetValue( "InputOutput", "whatInfo", "infoMinimal" );
		else 
			iniFile.SetValue( "InputOutput", "whatInfo", "infoStandard" );
	}
	else {
		if   (outputGroup->selected() == radioMaximum)
			iniFile.SetValue( "InputOutput", "whatInfo", "infoMax" );
		else if   (outputGroup->selected() == radioMinimum)
			iniFile.SetValue( "InputOutput", "whatInfo", "infoMinimal" );
		else 
			iniFile.SetValue( "InputOutput", "whatInfo", "infoStandard" );
	}

	// set the variable name
	if (modelGroup->selected() == radioOblique){
		if (whatInputGroup->selected() == radioAlpha){
	 		iniFile.SetValue( "InputOutput", "variableName", "deltaMV" );
		}
		else if  (whatInputGroup->selected() == radioTheta) {
	 		iniFile.SetValue( "InputOutput", "variableName", "thetaMV" );
		}
		else if  (whatInputGroup->selected() == radioDT) {
	 		iniFile.SetValue( "InputOutput", "variableName", "deltaThetaV" );
		}
		else if  (whatInputGroup->selected() == radioMx) {
	 		iniFile.SetValue( "InputOutput", "variableName", "MxV" );
		}
		else {
		}
	}
	else if (modelGroup->selected() == radioShockDynamics){
		if (whatInputGroup->selected() == radioAlpha){
	 		iniFile.SetValue( "InputOutput", "variableName", "UxpV" );
		}
		else if  (whatInputGroup->selected() == radioTheta) {
	 		iniFile.SetValue( "InputOutput", "variableName", "PyPxOpenV" );
		}
		else if  (whatInputGroup->selected() == radioDT) {
	 		iniFile.SetValue( "InputOutput", "variableName", "UsOpenV" );
		}
		else if  (whatInputGroup->selected() == radioMx) {
	 		iniFile.SetValue( "InputOutput", "variableName", "MxV" );
		}
		else if  (whatInputGroup->selected() == radioMy) {
	 		iniFile.SetValue( "InputOutput", "variableName", "MyV" );
		}
		else if  (whatInputGroup->selected() == radioMach) {
	 		iniFile.SetValue( "InputOutput", "variableName", "MxpV" );
		}
		else if  (whatInputGroup->selected() == radioP) {
	 		iniFile.SetValue( "InputOutput", "variableName", "MxOpenV" );
		}
		else if  (whatInputGroup->selected() == radioT) {
	 		iniFile.SetValue( "InputOutput", "variableName", "MyOpenV" );
		}
		else if  (whatInputGroup->selected() == radioR) {
	 		iniFile.SetValue( "InputOutput", "variableName", "MypOpenV" );
		}
		else if  (whatInputGroup->selected() == radioPAR) {
	 		iniFile.SetValue( "InputOutput", "variableName", "kV" );
		}
		else if  (whatInputGroup->selected() == radioFLD) {
	 		iniFile.SetValue( "InputOutput", "variableName", "MxGV" );
		}
		else if  (whatInputGroup->selected() == radioT0) {
	 		iniFile.SetValue( "InputOutput", "variableName", "MxpMypPCV" );
		}
		else if  (whatInputGroup->selected() == radioP0) {
	 		iniFile.SetValue( "InputOutput", "variableName", "MxpMypPOV" );
		}
		else if  (whatInputGroup->selected() == radioR0) {
	 		iniFile.SetValue( "InputOutput", "variableName", "MxpMyPOV" );
		}
		else { //defualt
		}
	}
	else if (modelGroup->selected() == radioisentropic){
		if (whatInputGroup->selected() == radioAlpha){
			iniFile.SetValue( "InputOutput", "variableName", "AstarV" );
		}
        else if (whatInputGroup->selected() == radioP0){
            iniFile.SetValue( "InputOutput", "variableName", "PbarV" );
        }
        else if (whatInputGroup->selected() == radioT0){
            iniFile.SetValue( "InputOutput", "variableName", "TbarV" );
        }
        else if (whatInputGroup->selected() == radioR0){
            iniFile.SetValue( "InputOutput", "variableName", "RbarV" );
        }
        else if (whatInputGroup->selected() == radioPAR){
            iniFile.SetValue( "InputOutput", "variableName", "PARV" );
        }
        else if (whatInputGroup->selected() == radioMach){
            iniFile.SetValue( "InputOutput", "variableName", "MachV" );
        }
	}
	else if (modelGroup->selected() == radioFanno){
		if (whatInputGroup->selected() == radioAlpha){
			iniFile.SetValue( "InputOutput", "variableName", "AstarV" );
		}
        else if (whatInputGroup->selected() == radioP){
            iniFile.SetValue( "InputOutput", "variableName", "PbarV" );
        }
        else if (whatInputGroup->selected() == radioT){
            iniFile.SetValue( "InputOutput", "variableName", "TbarV" );
        }
        else if (whatInputGroup->selected() == radioP0){
            iniFile.SetValue( "InputOutput", "variableName", "PRzeroStarV" );
        }
        else if (whatInputGroup->selected() == radioT0){
            iniFile.SetValue( "InputOutput", "variableName", "TbarV" );
        }
        else if (whatInputGroup->selected() == radioR){
            iniFile.SetValue( "InputOutput", "variableName", "RbarV" );
        }
        else if (whatInputGroup->selected() == radioR0){
            iniFile.SetValue( "InputOutput", "variableName", "RbarV" );
        }
        else if (whatInputGroup->selected() == radioFLD){
           iniFile.SetValue( "InputOutput", "variableName", "fldV" );
        }
        else if (whatInputGroup->selected() == radioMach){
            iniFile.SetValue( "InputOutput", "variableName", "MachV" );
        }
        else if (whatInputGroup->selected() == radioPAR){
            iniFile.SetValue( "InputOutput", "variableName", "M1fldV" );
        }
		else { 
            iniFile.SetValue( "InputOutput", "variableName", "MachV" );
		}
	}
	else if (modelGroup->selected() == radioIsothermal){
		if (whatInputGroup->selected() == radioAlpha){
			iniFile.SetValue( "InputOutput", "variableName", "AstarV" );
		}
        else if (whatInputGroup->selected() == radioP){
            iniFile.SetValue( "InputOutput", "variableName", "PbarV" );
        }
        else if (whatInputGroup->selected() == radioT){
            iniFile.SetValue( "InputOutput", "variableName", "TbarV" );
        }
        else if (whatInputGroup->selected() == radioP0){
            iniFile.SetValue( "InputOutput", "variableName", "PRzeroStarV" );
        }
        else if (whatInputGroup->selected() == radioT0){
            iniFile.SetValue( "InputOutput", "variableName", "TRzeroStarV" );
        }
        else if (whatInputGroup->selected() == radioR){
            iniFile.SetValue( "InputOutput", "variableName", "RbarV" );
        }
        else if (whatInputGroup->selected() == radioR0){
            iniFile.SetValue( "InputOutput", "variableName", "RbarV" );
        }
        else if (whatInputGroup->selected() == radioFLD){
           iniFile.SetValue( "InputOutput", "variableName", "fldV" );
        }
        else if (whatInputGroup->selected() == radioMach){
            iniFile.SetValue( "InputOutput", "variableName", "MachV" );
        }
		else { 
            iniFile.SetValue( "InputOutput", "variableName", "MachV" );
		}
	}
	else if (modelGroup->selected() == radioIsoNozzle){
        if (whatInputGroup->selected() == radioP){
            iniFile.SetValue( "InputOutput", "variableName", "PbarV" );
        }
        else if (whatInputGroup->selected() == radioR){
            iniFile.SetValue( "InputOutput", "variableName", "PbarV" );
        }
        else if (whatInputGroup->selected() == radioT){
            iniFile.SetValue( "InputOutput", "variableName", "TbarV" );
        }
        else if (whatInputGroup->selected() == radioP0){
            iniFile.SetValue( "InputOutput", "variableName", "PRzeroStarV" );
        }
        else if (whatInputGroup->selected() == radioT0){
            iniFile.SetValue( "InputOutput", "variableName", "TRzeroStarV" );
        }
        else if (whatInputGroup->selected() == radioR){
            iniFile.SetValue( "InputOutput", "variableName", "RbarV" );
        }
        else if (whatInputGroup->selected() == radioR0){
            iniFile.SetValue( "InputOutput", "variableName", "RbarV" );
        }
        else if (whatInputGroup->selected() == radioFLD){
           iniFile.SetValue( "InputOutput", "variableName", "fldV" );
        }
        else if (whatInputGroup->selected() == radioMach){
            iniFile.SetValue( "InputOutput", "variableName", "MachV" );
        }
		else { 
            iniFile.SetValue( "InputOutput", "variableName", "MachV" );
		}
	}
	else if (modelGroup->selected() == radioRayliegh){
		if (whatInputGroup->selected() == radioAlpha){
			iniFile.SetValue( "InputOutput", "variableName", "AstarV" );
		}
        else if (whatInputGroup->selected() == radioP){
            iniFile.SetValue( "InputOutput", "variableName", "PbarV" );
        }
        else if (whatInputGroup->selected() == radioT){
            iniFile.SetValue( "InputOutput", "variableName", "TbarV" );
        }
        else if (whatInputGroup->selected() == radioP0){
            iniFile.SetValue( "InputOutput", "variableName", "PRzeroStarV" );
        }
        else if (whatInputGroup->selected() == radioT0){
            iniFile.SetValue( "InputOutput", "variableName", "TRzeroStarV" );
        }
        else if (whatInputGroup->selected() == radioR){
            iniFile.SetValue( "InputOutput", "variableName", "RbarV" );
        }
        else if (whatInputGroup->selected() == radioR0){
            iniFile.SetValue( "InputOutput", "variableName", "RbarV" );
        }
        else if (whatInputGroup->selected() == radioFLD){
           iniFile.SetValue( "InputOutput", "variableName", "fldV" );
        }
        else if (whatInputGroup->selected() == radioMach){
            iniFile.SetValue( "InputOutput", "variableName", "MachV" );
        }
		else { 
            iniFile.SetValue( "InputOutput", "variableName", "MachV" );
		}
	}
	else if (whatInputGroup->selected() == radioP){
	 	iniFile.SetValue( "InputOutput", "variableName", "PbarV" );
	}
	else if (whatInputGroup->selected() == radioP0 &&
				modelGroup->selected() == radioShock) 
	 	iniFile.SetValue( "InputOutput", "variableName", "P0yP0xV" );
	else if ((whatInputGroup->selected() == radioP0 &&
				modelGroup->selected() == radioisentropic ) || 
	 		(whatInputGroup->selected() == radioP0 &&
				modelGroup->selected() == radiopm )  ||
	 		(whatInputGroup->selected() == radioP0 &&
				modelGroup->selected() == radioIsoNozzle )  ) 
	 	iniFile.SetValue( "InputOutput", "variableName", "PbarV" );
	else if (whatInputGroup->selected() == radioT0  &&
                modelGroup->selected() == radioShock)
	 	iniFile.SetValue( "InputOutput", "variableName", "T0yT0xV" );
	else if ((whatInputGroup->selected() == radioT0 &&
                modelGroup->selected() == radioisentropic) ||
			(whatInputGroup->selected() == radioT0 &&
                modelGroup->selected() == radiopm) ||
			(whatInputGroup->selected() == radioT0 &&
                modelGroup->selected() == radioIsoNozzle) ) 
		iniFile.SetValue( "InputOutput", "variableName", "TbarV" );
	else if ((whatInputGroup->selected() == radioR0)  &&
                modelGroup->selected() == radioShock)
	 	iniFile.SetValue( "InputOutput", "variableName", "R0yR0xV" );
	else if ((whatInputGroup->selected() == radioR0 &&
				modelGroup->selected() == radioisentropic) ||
			(whatInputGroup->selected() == radioR0 &&
				modelGroup->selected() == radiopm) )
		iniFile.SetValue( "InputOutput", "variableName", "RbarV" );
	else if (whatInputGroup->selected() == radioT)
	 	iniFile.SetValue( "InputOutput", "variableName", "TbarV" );
	else if (whatInputGroup->selected() == radioR)
	 	iniFile.SetValue( "InputOutput", "variableName", "RbarV" );
	else if (whatInputGroup->selected() == radioMx)
	 	iniFile.SetValue( "InputOutput", "variableName", "MxV" );
	else if (whatInputGroup->selected() == radioMy)
	 	iniFile.SetValue( "InputOutput", "variableName", "MyV" );
	else if (whatInputGroup->selected() == radioAlpha)
	 	iniFile.SetValue( "InputOutput", "variableName", "angleV" );
    else if (whatInputGroup->selected() == radioFLD)
        iniFile.SetValue( "InputOutput", "variableName", "fldV" );
    else if (whatInputGroup->selected() == radioMach)
        iniFile.SetValue( "InputOutput", "variableName", "MachV" );
    else  // default 
        iniFile.SetValue( "InputOutput", "variableName", "MachV" );

// set model flow
	if (modelGroup->selected() == radioShock)
	 	iniFile.SetValue( "InputOutput", "className", "shockFlow" );
	else if (modelGroup->selected() == radiopm)
        iniFile.SetValue( "InputOutput", "className", "pmFlow" );
	else if (modelGroup->selected() == radioisentropic)
        iniFile.SetValue( "InputOutput", "className", "isentropicFlow" );
	else if (modelGroup->selected() == radioIsoNozzle)
        iniFile.SetValue("InputOutput", "className","isothermalNozzleFlow" );
	else if (modelGroup->selected() == radioFanno)
        iniFile.SetValue( "InputOutput", "className", "fannoFlow" );
	else if (modelGroup->selected() == radioIsothermal)
        iniFile.SetValue( "InputOutput", "className", "isothermalFlow" );
	else if (modelGroup->selected() == radioRayliegh)
        iniFile.SetValue( "InputOutput", "className", "raylieghFlow" );
	else if (modelGroup->selected() == radioOblique)
        iniFile.SetValue( "InputOutput", "className", "obliqueFlow" );
	else if (modelGroup->selected() == radioShockDynamics)
        iniFile.SetValue( "InputOutput", "className", "shockDynamicsFlow" );
	else // default 
        iniFile.SetValue( "InputOutput", "className", "isentropicFlow" );

	iniFile.WriteFile(); 
	//iniFile.close();
}


void gdForm::removeInpossibleInput()
{
	isDataChanged = true;
	if (modelGroup->selected() == radioisentropic) {
		if ( whatInputGroup->selected() == radioMx &&
			whatInputGroup->selected() == radioMy) 
			radioMx->setChecked(false);	
			radioMy->setChecked(false);	
			radioAlpha->setChecked(false);	
			radioTheta->setChecked(false);	
			radioT->setChecked(false);	
			radioP->setChecked(false);	
			radioR->setChecked(false);	
			radioFLD->setChecked(false);	
			setInput();
	} 
	if (modelGroup->selected() == radioShock) {
        if ( whatInputGroup->selected() == radioPAR &&
            whatInputGroup->selected() == radioAlpha)
            radioPAR->setChecked(false);
            radioAlpha->setChecked(false);
            radioTheta->setChecked(false);
            setInput();
    }
}

int gdForm::canSave()
{
    QString notice,  caption;
    if (modelGroup->selected() == 0 ){
        notice = "<h2>Gas Dymanics Calculator 0.4.3.3</h2>" ;
        notice += "<p>You need to select the model radio";
        QMessageBox::warning (this , "Gas Dymanics Calculator", notice);//,
//                   QMessageBox::Ok );
        return false; 
    }
    else if (whatInputGroup->selected() == 0 ){
        notice = "<h2>Gas Dymanics Calculator 0.4.3.3</h2>" ;
        notice += "<p>You need to select the what Info radio";
        QMessageBox::warning (this , "Gas Dymanics Calculator", notice);//,
//                   QMessageBox::Ok );
        return false;
    }
	else {
		return true;
	}
}

void gdForm::valueChange(double k)
{
    //QString notice,  caption;
    //notice = "<h2>Gas Dymanics Calculator 0.4.3.3</h2>" ;
    //notice += "<p>You need to select the what Info radio";
    //QMessageBox::warning (this , "Gas Dymanics Calculator", notice);
	double * tmpRange;
	QString notice, notice1  ;
	isDataChanged = true;
	//notImplementedYet();
	k = kInput->value();
	if (modelGroup->selected() == radioShock ){// &&
		MyInput->setRange( sqrt(.5*(k -1.)/k)+EPS, 1.0);
		tmpRange = MyInput->getRange();
		MyInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
	}
	else if (modelGroup->selected() == radioisentropic ){
		if ((inputDataGroup->selected() == radioSuperSonic) || 
		( MachInput->value() >= 1.0)) { //supersonic flow M > 1
			//k = kInput->value();
			p0Input->setRange(0.0+EPS, 1.0);
			TbarInput->setRange(0.0+EPS, 1.0);
			RbarInput->setRange(0.0+EPS, 1.0);
			PARInput->setRange(0.0+EPS, 1.0 );
		}
		else {
			p0Input->setRange(pow((2.0/(k+1)), (k /(k -1.))), 1.0 );
			TbarInput->setRange((2.0/(k+1)), 1.0 );
			RbarInput->setRange( pow((2.0/(k+1)), (1. /(k -1.))), 1.0 );
			PARInput->setRange(1.0+EPS, 300.0 );
		}
	}
	else if (modelGroup->selected() == radioShockDynamics ){
		notImplementedYet();
		if (whatShockDynamicsGroup->selected() == suddenOpenRadio ){ 
			MyInput->setRange ( EPS, sqrt(2./k / (k -1.)) - EPS );
			tmpRange = MyInput->getRange();
			MyInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
		}
		else if (whatShockDynamicsGroup->selected() == PartiallyCloseRadio ){ 
			
		}
		//else if (whatShockDynamicsGroup->selected() == PartiallyOpenRadio){ 
		//	MyInput->setRange ( MxInput->value()+EPS, 1.5 );
		//	tmpRange = MyInput->getRange();
		//	MyInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
		//}
	}
	else if (modelGroup->selected() == radioIsoNozzle ){
		double M1maxSub =  1./sqrt(k);
		p0Input->setRange(0.0+EPS,
			 2.*exp(k*0.5) *pow(((k+1.)/2.),(k/(k-1.))) /(k+1.) );
		tmpRange = p0Input->getRange();
		p0Input->setValue(0.5*(tmpRange[0]+tmpRange[1]));
		TbarInput->setRange(
			2.*exp(k*0.5) *pow(((k+1.)/2.),(k/(k-1.))) /(k+1.) , 10.0 );
		tmpRange = TbarInput->getRange();
		TbarInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));

		pInput->setRange(0.0+EPS, exp(k*0.5) );
		tmpRange = pInput->getRange();
		pInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));

		rInput->setRange(0.0+EPS, exp(k*0.5) );
		tmpRange = rInput->getRange();
		rInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
		if ( MachInput->value() >= M1maxSub ){ //supersonic flow M >1/sqrt(k)
			// only for the area ratio
			//TbarInput->setRange(0.0+EPS, (2.0/(k+1)) );
		notice = "<h2>Gas Dymanics Calculator 0.4.3.3</h2>" ;
		notice += "<p>The Mach number is:   ";
    	notice += notice1.setNum( MachInput->value());
		notice += "<p>The upper limit  is:   ";
    	notice += notice1.setNum( M1maxSub );
		notice += "<p>The k value  is:   ";
    	notice += notice1.setNum( k);
		//notice += "<p>The base value  is:   ";
    	//notice += notice1.setNum( (2.0/(k+1)));
		//notice += "<p>The power value  is:   ";
    	//notice += notice1.setNum( (k /(k -1.)) );

		} 
		else { // subsonic
			//p0Input->setRange(1., 2. );
			//RbarInput->setRange(0.0+EPS, 1.0);
		notice = "<h2>Gas Dymanics Calculator 0.4.3.3</h2>" ;
		notice += "<p>The Mach number is:   ";
    	notice += notice1.setNum( MachInput->value());
		notice += "<p>The upper limit  is:   ";
    	notice += notice1.setNum( M1maxSub );
		notice += "<p>The k value  is:   ";
    	notice += notice1.setNum( k);
		notice += "<p>The range is:   ";
		tmpRange = p0Input->getRange();
		p0Input->setValue(0.5*(tmpRange[0]+tmpRange[1]));
    	notice += notice1.setNum( tmpRange[0] );
		notice += "<p>The upper limit  is:   ";
    	notice += notice1.setNum( tmpRange[1] );
		}
		QMessageBox::warning (this , "Gas Dymanics Calculator", notice);
	}
	else if (modelGroup->selected() == radioFanno ){
		k = kInput->value();
		double superSonicFLD, M1maxSub; 
		M1maxSub= 1.0;
		superSonicFLD = 0.821508116; // to change to account k
		FLDInput->setRange(0.0+EPS, 500.0);
		tmpRange = p0Input->getRange();
		FLDInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
		//TbarInput->setRange(0. , 10.0 );
		//tmpRange = TbarInput->getRange();
		//TbarInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));

		//pInput->setRange(0.0+EPS, exp(k*0.5) );
		//tmpRange = pInput->getRange();
		//pInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));

		//rInput->setRange(0.0+EPS, exp(k*0.5) );
		//tmpRange = rInput->getRange();
		//rInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
        if ((inputDataGroup->selected() == radioSuperSonic) ||
        ( MachInput->value() >= 1.0)) { //supersonic flow M > 1
			notice = "<h2>Gas Dymanics Calculator 0.4.3.3</h2>" ;
			notice += "<p>The Mach number is:   ";
			notice += notice1.setNum( MachInput->value());
			notice += "<p>The upper limit  is:   ";
			notice += notice1.setNum( M1maxSub );
			notice += "<p>The k value  is:   ";
			notice += notice1.setNum( k);
			FLDInput->setRange(0.0+EPS, superSonicFLD  );
			//notice += "<p>The base value  is:   ";
			//notice += notice1.setNum( (2.0/(k+1)));
			//notice += "<p>The power value  is:   ";
			//notice += notice1.setNum( (k /(k -1.)) );
		} 
		else { // subsonic
			//p0Input->setRange(1., 2. );
			//RbarInput->setRange(0.0+EPS, 1.0);
			FLDInput->setRange(0.0+EPS, 500.  );
			notice = "<h2>Gas Dymanics Calculator 0.4.3.3</h2>" ;
			notice += "<p>The Mach number is:   ";
			notice += notice1.setNum( MachInput->value());
			notice += "<p>The upper limit  is:   ";
			notice += notice1.setNum( M1maxSub );
			notice += "<p>The k value  is:   ";
			notice += notice1.setNum( k);
			notice += "<p>The range is:   ";
			FLDInput->setRange(0.0+EPS, 500.0);
			tmpRange = FLDInput->getRange();
			FLDInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
			notice += notice1.setNum( tmpRange[0] );
			notice += "<p>The upper limit  is:   ";
			notice += notice1.setNum( tmpRange[1] );
		}
		//QMessageBox::warning (this , "Gas Dymanics Calculator", notice);
	}
	tmpRange = p0Input->getRange();
	p0Input->setValue(0.5*(tmpRange[0]+tmpRange[1]));
	tmpRange = TbarInput->getRange();
	TbarInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
	tmpRange = RbarInput->getRange();
	RbarInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
	tmpRange = FLDInput->getRange();
	FLDInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
	//setNoticeIfNeeded();
}

void gdForm::Load()
{
	QString fn = QFileDialog::getOpenFileName( ".",
	"gdc files (*.gdc *.ini *.dat );;"
	"Text files (*.txt);;"
	"Any files (*)" ,
		   this, "Load file dialog" "Choose file to load");
																			
		// to set up the extension for the file name
	if ( !fn.isEmpty() ) {
		filename = fn;
		isDataChanged = false;
		//fileSave();
	}
}

void gdForm::newValues()
{
	isDataChanged = true ;
}



void gdForm::selectBranch()
{
	radioSubSonic->setEnabled(true);
	radioSubSonic->setShown(true);
	radioSuperSonic->setEnabled(true);
	radioSuperSonic->setShown(true);
	radioBothSonic->setEnabled(true);
	radioSubSonic->setChecked(true);
}


void gdForm::valueChange()
{
	double k;
	k = kInput->value();
	//rangeNotice->setShown(false);
	if (inputDataGroup->selected() ==  radioSubSonic) {
		PARInput->setRange(1.0+EPS, 300.0 );
		p0Input->setRange( pow((2.0/(k+1)), (k /(k -1.))), 1.0 );
		TbarInput->setRange((2.0/(k+1)), 1.0 );
		RbarInput->setRange(pow((2.0/(k+1)), (1. /(k -1.))), 1.0 );
		FLDInput->setRange(0.0+EPS, 500.  );
	}
	else if (inputDataGroup->selected() ==  radioSuperSonic ) {
		PARInput->setRange(0.0+EPS, 1.0 );
		p0Input->setRange(0.0+EPS, 1.0);
		TbarInput->setRange(0.0+EPS, 1.0);
		RbarInput->setRange(0.0+EPS, 1.0);
        double superSonicFLD = 0.821508116; // to change to account k
		FLDInput->setRange(0.0+EPS, superSonicFLD  );
    //QMessageBox::about(this , "You selected: ", "Super Flow" );
	}
	//reset the value
	double * tmpRange;
    tmpRange = p0Input->getRange();
    p0Input->setValue(0.5*(tmpRange[0]+tmpRange[1]));
    tmpRange = TbarInput->getRange();
    TbarInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
    tmpRange = RbarInput->getRange();
    RbarInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
    tmpRange = PARInput->getRange();
    PARInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
	//setInput();
	setNoticeIfNeeded();
}

void gdForm::setNotice(InputType whatInput )
{
	QString notice, notice1,  caption;
	double * tmpRange;
	tmpRange = new double[2]; 
	//->setShown(true);
	if (whatInput == iMx ){
		tmpRange = MxInput->getRange();
	}
    else if (whatInput == iMy ){
        tmpRange = MyInput->getRange();
    }
    else if (whatInput == iP0 ){
        tmpRange = p0Input->getRange();
    }
    else if (whatInput == iT0 ){
        tmpRange = p0Input->getRange();
    }
    else if (whatInput == iR0 ){
        tmpRange = p0Input->getRange();
    }
    else if (whatInput == iP ){
        tmpRange = pInput->getRange();
    }
    else if (whatInput == iT ){
        tmpRange = TInput->getRange();
    }
    else if (whatInput == iR ){
        tmpRange = rInput->getRange();
    }
    else if (whatInput == iPAR ){
        tmpRange = PARInput->getRange();
    }
	notice = "<b>The possible Range is</b><br>" ;
	notice += "lowest value is : " ;
	notice += notice1.setNum(  tmpRange[0]);
	notice += "<br>" ;
	notice += "highest value is: ";
	notice += notice1.setNum(  tmpRange[1]);
	rangeNotice->setText(notice);
}

void gdForm::setNoticeIfNeeded()
{
	//InputType inputBox;
	//if (whatInputGroup->selected() != 0){
	//	inputBox=iMx;
	//	setNotice(inputBox);
	//}
}


void gdForm::branchSelected()
{
	double * tmpRange;
	tmpRange = new double[2];
	double k ;
    k =  kInput->value();
	double superSonicFLD, M1maxSub;
	M1maxSub= 1.0;
	superSonicFLD = 0.821508116; // to change to account k

	if (modelGroup->selected() == radioIsothermal) {
		if (inputDataGroup->selected() == radioSuperSonic){ 
			FLDInput->setRange((.0+EPS), 300.);
		}
		else {
			FLDInput->setRange((.0+EPS), 500.);
		}
	}
	if (modelGroup->selected() == radioisentropic) {
		if (inputDataGroup->selected() == radioSuperSonic){ 
			p0Input->setRange(0. ,pow((2.0/(k+1.)), (k /(k -1.))) );
			TbarInput->setRange(0. ,(2.0/(k+1.)) );
			RbarInput->setRange(0., pow((2.0/(k+1.)), (1. /(k -1.))) );
		}
		else {
			p0Input->setRange(pow((2.0/(k+1.)), (k /(k -1.))) ,1.0);
			TbarInput->setRange((2.0/(k+1.)) ,1.0);
			RbarInput->setRange(pow((2.0/(k+1.)), (1. /(k -1.))) ,1.0);
		}
	}
	if (modelGroup->selected() == radioFanno) {
		if (inputDataGroup->selected() == radioSuperSonic){ 
			p0Input->setRange(0. ,pow((2.0/(k+1.)), (k /(k -1.))) );
			TbarInput->setRange(0. ,(2.0/(k+1.)) );
			RbarInput->setRange(0., pow((2.0/(k+1.)), (1. /(k -1.))) );
			FLDInput->setRange(0.0+EPS, superSonicFLD  );
		}
		else {
			p0Input->setRange(pow((2.0/(k+1.)), (k /(k -1.))) ,1.0);
			TbarInput->setRange((2.0/(k+1.)) ,1.0);
			RbarInput->setRange(pow((2.0/(k+1.)), (1. /(k -1.))) ,1.0);
			FLDInput->setRange(0.0+EPS, 500.  );
		}
	}
	if (modelGroup->selected() == radioRayliegh) {
		if (inputDataGroup->selected() == radioSuperSonic){ 
			p0Input->setRange(1.0, 300.);
            t0Input->setRange((k+1.)*(k-1.0)/k , 1.0);
			TbarInput->setRange(0. ,(2.0/(k+1.)) );
			RbarInput->setRange(0., pow((2.0/(k+1.)), (1. /(k -1.))) );
			FLDInput->setRange(0.0+EPS, superSonicFLD  );
		}
		else {
            p0Input->setRange(1.0, (k+1.)*pow(2./(k+1.),k/(k-1.0)));
			t0Input->setRange(.0, 1.);
			TbarInput->setRange((2.0/(k+1.)) ,1.0);
			RbarInput->setRange(pow((2.0/(k+1.)), (1. /(k -1.))) ,1.0);
			FLDInput->setRange(0.0+EPS, 500.  );
		}
	}
	if (modelGroup->selected() == radioIsoNozzle) {
		if (inputDataGroup->selected() == radioSuperSonic){ 
			pInput->setRange(0., 1.0 );
			rInput->setRange(0., 1.0 );
			p0Input->setRange(.0, 1.);
			t0Input->setRange(1., 300. );
			RbarInput->setRange(0., pow((2.0/(k+1.)), (1. /(k -1.))) );
			FLDInput->setRange(0.0+EPS, superSonicFLD  );
		}
		else {
			pInput->setRange(1., exp(k*0.5) );
			rInput->setRange(1., exp(k*0.5) );
			p0Input->setRange(1., exp(k*0.5)* pow((2.0/(k+1.)), (k /(k -1.))) );
			t0Input->setRange(2./(k+1.), 1.);
			RbarInput->setRange(pow((2.0/(k+1.)), (1. /(k -1.))) ,1.0);
			FLDInput->setRange(0.0+EPS, 500.  );
		}
	}
	tmpRange = rInput->getRange();
	rInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
	tmpRange = FLDInput->getRange();
	FLDInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
	tmpRange = pInput->getRange();
	pInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
	tmpRange = p0Input->getRange();
	p0Input->setValue(0.5*(tmpRange[0]+tmpRange[1]));
	tmpRange = t0Input->getRange();
	t0Input->setValue(0.5*(tmpRange[0]+tmpRange[1]));
	tmpRange = t0Input->getRange();
	TbarInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
	tmpRange = RbarInput->getRange();
	RbarInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
	tmpRange = FLDInput->getRange();
	FLDInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
}


void gdForm::allowMaxOblique()
{
    if (modelGroup->selected() == radioOblique){
		radioMy->setEnabled(true);
		radioMx->setEnabled(true);
		radioMy->setShown(true);
		radioMx->setShown(true);
		radioMx->setText("Mx(max)");
	}
}


void gdForm::setShockDynamics()
{
	if (modelGroup->selected() == radioShockDynamics) {	
		whatShockDynamicsGroup->setShown(true);
		whatShockDynamicsGroup->setEnabled(true);
		intoStillRadio->setEnabled(true);
		intoStillRadio->setShown(true);
		PartiallyCloseRadio->setEnabled(true);
		PartiallyCloseRadio->setShown(true);
		PartiallyOpenRadio->setShown(true);
		PartiallyOpenRadio->setEnabled(true);
		suddenOpenRadio->setEnabled(true);
		suddenOpenRadio->setShown(true);
		//suddenOpenRadio->setChecked(true);
		//generalDynamicsRadio->setChecked(true);
		//intoStillRadio->setChecked(false);
		//generalDynamicsRadio->setChecked(false);
		//intoStillRadio->setChecked(false);
	}
}


void gdForm::clearShockDynamicsInput()
{
	intoStillRadio->setEnabled(false);
	intoStillRadio->setChecked(false);
	intoStillRadio->setShown(false);
	PartiallyCloseRadio->setEnabled(false);
	PartiallyCloseRadio->setChecked(false);
	PartiallyCloseRadio->setShown(false);
	suddenOpenRadio->setEnabled(false);
	suddenOpenRadio->setChecked(false);
	suddenOpenRadio->setShown(false);
	whatShockDynamicsGroup->setShown(false);
	PartiallyOpenRadio->setEnabled(false);
	PartiallyOpenRadio->setChecked(false);
	PartiallyOpenRadio->setShown(false);
}

void gdForm::setShockDynamicsInput()
{
	clearRadio();
	clearInputBoxs();
	if (whatShockDynamicsGroup->selected() == intoStillRadio ) {
		radioMy->setEnabled(true);
		radioMy->setText("My");
		radioMx->setText("Mx");
		radioMx->setEnabled(true);
		radioMy->setShown(true);
		radioMx->setShown(true);
		radioMach->setEnabled(true);
		radioMach->setShown(true);
		radioMach->setText("Mx'");
		//radioP->setEnabled(true);
		//radioT->setEnabled(true);
		//radioT->setShown(true);
		//radioP->setShown(true);
		//radioP->setText("Px");
		//radioT->setText("Tx");
		//radioR->setEnabled(true);
		//radioR->setText("R2/R1");
		//radioMach->setEnabled(true);
		//radioFLD->setEnabled(true);
		//radioMy->setEnabled(true);
		//radioPAR->setEnabled(true);
		//radioDT->setEnabled(true);
		//radioDT->setText("Delta and Theta");
		radioAlpha->setEnabled(true);
		radioAlpha->setShown(true);
		radioAlpha->setText("Ux'");
		//radioTheta->setEnabled(true);
		//radioTheta->setText("Theta and Mx");
		//radioP0->setEnabled(true);
		//radioMx->setEnabled(true);
		//radioT0->setEnabled(true);
	}
	else if (whatShockDynamicsGroup->selected() == suddenOpenRadio ) {
		radioP->setText("Mx");
		radioP->setEnabled(true);
		radioP->setShown(true);
		radioT->setText("My");
		radioT->setEnabled(true);
		radioT->setShown(true);
		radioR->setText("My'");
		radioR->setEnabled(true);
		radioR->setShown(true);
		radioPAR->setText("k");
		radioPAR->setEnabled(true);
		radioPAR->setShown(true);
		radioTheta->setEnabled(true);
		radioTheta->setShown(true);
		radioTheta->setText("PyPx");
		//radioP->setEnabled(true);
		//radioT->setEnabled(true);
		//radioT->setShown(true);
		//radioP->setShown(true);
		//radioP->setText("Px");
		//radioT->setText("Tx");
		//radioR->setEnabled(true);
		//radioR->setText("R2/R1");
		//radioMach->setEnabled(true);
		//radioFLD->setEnabled(true);
		//radioMy->setEnabled(true);
		//radioPAR->setEnabled(true);
		radioDT->setEnabled(true);
		radioDT->setShown(true);
		radioDT->setText("Us Tx");
		//radioTheta->setEnabled(true);
		//radioTheta->setText("Theta and Mx");
		//radioP0->setEnabled(true);
		//radioMx->setEnabled(true);
		//radioT0->setEnabled(true);
	}
	else if (whatShockDynamicsGroup->selected() == PartiallyOpenRadio ) {
		//notImplementedYet();
		radioP0->setText("Mx'My'");
		radioP0->setEnabled(true);
		radioP0->setShown(true);
		radioR0->setText("Mx'My");
		radioR0->setEnabled(true);
		radioR0->setShown(true);
	}
	else if (whatShockDynamicsGroup->selected() == PartiallyCloseRadio ) {
		radioFLD->setText("MxMy'");
		radioFLD->setEnabled(true);
		radioFLD->setShown(true);
		radioT0->setText("Mx'My'");
		radioT0->setEnabled(true);
		radioT0->setShown(true);
	}
}

void gdForm::notImplementedYet()
{
    QString notice,  caption;
    notice = "<h2>Gas Dynamics Calculator 0.4.3.3</h2>" ;
    notice += "<p>Copyright &copy; 2005, 2006 Dr. Genick Bar-Meir";
    notice += "<p>This function is not implemented yet. " ;
                                                                             
    QMessageBox::about(this , "About Gas Dynamics Calculator", notice );
}


void gdForm::clearInfoBox()
{
    radioStandard->setEnabled(false);
    //radioStandard->setChecked( false );
    radioStandard->setShown(false);
	radioStandard->setText("");
	radioMinimum->setText("");
	radioMinimum->setEnabled(false);
	radioMinimum->setShown(false);
	radioMaximum->setText("");
	radioMaximum->setEnabled(false);
	radioMaximum->setShown(false);
}


void gdForm::setInfoBoxs()
{
	clearInfoBox();
    if (modelGroup->selected() == radioShockDynamics){
		radioStandard->setText("Standard");
    	radioStandard->setEnabled(true);
		radioStandard->setShown(true);
		radioMinimum->setText("Iteration");
		radioMinimum->setEnabled(true);
		radioMinimum->setShown(true);
		radioMaximum->setText("Maximum for k");
		radioMaximum->setEnabled(true);
		radioMaximum->setShown(true);
	}
    else if (modelGroup->selected() == radioFanno){
		radioStandard->setText("Standard");
    	radioStandard->setEnabled(true);
		radioStandard->setShown(true);
		radioMinimum->setText("Minimum");
		radioMinimum->setEnabled(true);
		radioMinimum->setShown(true);
		radioMaximum->setText("Iteration");
		radioMaximum->setEnabled(true);
		radioMaximum->setShown(true);
	}
	else {
		radioStandard->setText("Standard");
    	radioStandard->setEnabled(true);
		radioStandard->setShown(true);
		radioMinimum->setText("Minimum");
		radioMinimum->setEnabled(true);
		radioMinimum->setShown(true);
	} 
}


void gdForm::newData()
{
	//notImplementedYet();
	double k ;
	k = kInput->value();
	double * tmpRange;
	tmpRange = new double[2];
	if (modelGroup->selected() == radioShockDynamics ){
		//notImplementedYet();
		if (whatShockDynamicsGroup->selected() == suddenOpenRadio ){ 
			MyInput->setRange ( EPS, sqrt(2./k / (k -1.)) - EPS );
			tmpRange = MyInput->getRange();
			MyInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
		}
		else if (whatShockDynamicsGroup->selected() == PartiallyCloseRadio ){ 
			
		}
		else if (whatShockDynamicsGroup->selected() == PartiallyOpenRadio){ 
			MxInput->setRange ( 0. ,MyInput->value() -EPS );
			if ( MxInput->value() >= MyInput->value() ) {
				if ( whatInputGroup->selected() == radioP0 ) {
					tmpRange = MxInput->getRange();
					MxInput->setValue(0.5*(tmpRange[0]+tmpRange[1]));
				}
			}
		}
	}
}
